semidiscrete
============

Python bindings for the semidiscrete RT model of Gobron et al.

Note this version includes adjoint code developed by N Gobron, T Kaminski, 
P Lewis and J Gomez-Dans derived from the original NADIM/semidiscrete. These
modifications were funded by the ESA `EOLDAS <http://www.assimila.eu/eoldas>`_
project.

The original semidiscrete code can be found `here <http://fapar.jrc.ec.europa.eu/WWW/Data/Pages/FAPAR_Software/FAPAR_Software_RTModels_1-2Discrete.php>`_

The copyright for the original code is

    Copyrights
    (c) Nadine Gobron, Bernard Pinty, and Michel M. Verstraete 1997 The copyrights for these 8 files, including the computer codes, remain with their authors, Drs. Nadine Gobron, Bernard Pinty and Michel M. Verstraete.

    Academic users
    You are authorized to use this code for your research and teaching, but you must acknowledge use of this routine explicitly and refer to the paper above in any publication or work for which you used these codes. 
    You may distribute, free of charge, the unmodified version of these codes to colleagues involved in similar activities, provided you include all the in-line documentation. They, in turn, must agree with and abide by the same rules. 
    You may not sell this code to anybody, and you may not distribute it to commercial interests under any circumstances.

    Commercial and other users
    Use of this code (NADIM) in commercial applications is strictly forbidden without the written approval of the authors. Even with such an authorization to use the code, you may not distribute or sell it to any other commercial or business partners under any circumstances.

    

! -*- f90 -*-
      module mo_rtmodel
      implicit none
      integer nwmax
      double precision, parameter :: rtmodel_spectralInterval = 1.0
      double precision, parameter :: rtmodel_spectralMin = 400.0
      double precision, parameter :: rtmodel_spectralMax = 2500.0
      integer, parameter :: rtmodel_nparam = 13 
      integer, parameter :: rtmodel_version = 1
      integer, parameter :: rtmodel_subversion = 1
      integer :: lad
      double precision :: xlai
      double precision :: xhc
      double precision :: rpl
      double precision :: xs1,xs2,xs3,xs4
      double precision :: xkab,xkar,xkw,xkm,xleafn
      double precision :: xlai_ad
      double precision :: xhc_ad
      double precision :: rpl_ad
      double precision :: xs1_ad,xs2_ad,xs3_ad,xs4_ad
      double precision :: xkab_ad,xkar_ad,xkw_ad,xkm_ad,xleafn_ad
      double precision, parameter :: slai=-2.0
      double precision, parameter :: skab=-100.0
      double precision, parameter :: skar=-100.0
      double precision, parameter :: skw=(-1./50.)
      double precision, parameter :: skm=(-1./100.)
      character(2000),parameter :: rtmodel_param_names = "exp(-LAI/2.0):Canopy height:Leaf radius:&
           exp(-chlophyll/100.):leaf brown pigments:exp(-50. leaf water):exp(-100 leaf dry matter):&
           leaf layers (N):soil cmpt 1:&
           soil cmpt 2:soil cmpt 3:soil cmpt 4:lidf:"
      character(2000),parameter :: rtmodel_param_minmax = &
   "0.001;0.999:0.001;10:0.0001;1.0:0.001;0.999:0;1:0.001;0.999:0.001;0.999:0.5;2.5:0;1:0;1:0;1:0;1:0;5:"

! NB string list termined and separated by :
      contains 
      subroutine mo_rtzero_ad
      rpl_ad = 0.
      xhc_ad = 0.
      xlai_ad = 0.
      xs1_ad = 0.
      xs2_ad = 0.
      xs3_ad = 0.
      xs4_ad = 0.
      xkab_ad = 0.
      xkar_ad = 0.
      xkw_ad = 0.
      xkm_ad = 0.
      xleafn_ad = 0.
      end subroutine mo_rtzero_ad
      subroutine mo_rtsum_ad(x)
      implicit none
      double precision :: x(:)
      if(xlai_ad .ne. 0 .and. xlai .gt. 0 )x(1) = x(1) + xlai_ad * (slai/exp(xlai/slai))
      x(2) = x(2) + xhc_ad
      x(3) = x(3) + rpl_ad
      if(xkab_ad .ne. 0 .and. xkab .gt. 0) x(4) = x(4) + xkab_ad * (skab/exp(xkab/skab))
      if(xkar_ad .ne. 0 .and. xkar .gt. 0) x(5) = x(5) +  xkar_ad !* (skar/exp(xkar/skar))
      if(xkw_ad .ne. 0 .and. xkw .gt. 0 )x(6) = x(6) + xkw_ad * ((skw)/exp(xkw/skw))
      if(xkm_ad .ne. 0 .and. xkm .gt. 0)x(7) = x(7) + xkm_ad * ((skm)/exp(xkm/skm))
      x(8) = x(8) + xleafn_ad
      x(9) = x(9) + xs1_ad
      x(10) = x(10) + xs2_ad
      x(11) = x(11) + xs3_ad
      x(12) = x(12) + xs4_ad
! zero for lad
      x(13) = 0
      call mo_rtzero_ad()
      end subroutine mo_rtsum_ad

      subroutine mo_rtload(x)
      implicit none
      double precision :: x(:)
      xlai=0
      if(x(1) .gt. 0)xlai=slai*log(x(1))
      xhc=x(2)
      rpl=x(3)
      xkab=0
      if(x(4).gt.0)xkab=skab*log(x(4))
      xkar=0
      if(x(5) .gt.0)xkar=x(5) !skar*log(x(5))
      xkw=0.
      if(x(6) .gt. 0)xkw =skw*log(x(6))
      xkm =0
      if(x(7) .gt. 0 )xkm =skm*log(x(7))
      xleafn =x(8)
      xs1 =x(9)
      xs2 =x(10)
      xs3 =x(11)
      xs4 =x(12)
      lad = int(x(13)+0.5)
      end subroutine mo_rtload
! interface fn that doesnt require the module to be loaded
      end module mo_rtmodel

! this gets called before the rt model is ever called
! use it for any allocation / initialisation prep
subroutine rt_modelpre(nbands_to_use,bands_to_use)
	use mo_rtmodel
      use mo_nad
      implicit none
      integer nbands_to_use
      integer bands_to_use(nbands_to_use)
      nwmax = nbands_to_use
      nwmaxx = nbands_to_use
      call leafprep(nbands_to_use,bands_to_use)
      call nad_allocate(nbands_to_use)
end subroutine rt_modelpre

! use this eg for priniting anything interesting 
! or any additional deallocation etc
subroutine rt_modelpost()
      return
end subroutine rt_modelpost

subroutine rt_modeldpre(npt)
      implicit none
      integer npt,nw
! set the dimensions of multkl_multiple_dom
! and multl_multiple_dom
      call nad_mult_n(npt)
! make sure deallocated first
      call nad_mult_deallocate()
      call nad_mult_allocate()
end subroutine rt_modeldpre

subroutine rt_modeldpost()
	use dataspec_p5
      implicit none

      call deallocatespectra()
      call nad_mult_deallocate()
end subroutine rt_modeldpost

subroutine rt_model(nv,nbands,nl,ipt,x,theta_v,phi_v,theta_i,phi_i,brf,wb)
      use mo_rtmodel
!!!!!f2py intent(c) theta_v,phi_v,x,wb
      implicit none
      integer :: nv,nbands,nl
      integer :: ipt
      double precision, intent(out) :: brf(nv,nbands)
      double precision :: theta_v(nv),phi_v(nv),theta_i,phi_i
      double precision :: x(rtmodel_nparam)
      double precision :: wb(nbands,nl)

      call mo_rtload(x)
      brf = 0.
	!print*,size(wb(:,1)),nl,nv,nwmax
      call msnadimbrf(size(wb(:,1)),nl,nv,lad,xkab,xkar,xkw,xkm,xleafn,&
           xs1,xs2,xs3,xs4,theta_i,phi_i,theta_v,phi_v,xhc,xlai,rpl,brf,wb)
      return
end subroutine rt_model

subroutine rt_modelpred(nv,nbands,nl,ipt,x,theta_v,phi_v,theta_i,phi_i,brf,wb)
      use mo_rtmodel
!!!!!f2py intent(c) theta_v,phi_v,x,wb
      implicit none
      integer :: nv,nbands,nl
      integer :: ipt
      double precision, intent(out) :: brf(nv,nbands)
      double precision :: theta_v(nv),phi_v(nv),theta_i,phi_i
      double precision :: x(rtmodel_nparam)
      double precision :: wb(nbands,nl)

      call mo_rtload(x)
      brf = 0.
      call msnadimbrfmd(ipt,size(wb(:,1)),nl,nv,lad,xkab,xkar,xkw,xkm,xleafn,&
           xs1,xs2,xs3,xs4,theta_i,phi_i,theta_v,phi_v,xhc,xlai,rpl,brf,wb)
      return
end subroutine rt_modelpred

subroutine rt_modeld(nv,nbands,nl,ipt,x,theta_v,phi_v,theta_i,phi_i,brff_ad,wb,x_ad)
      use mo_rtmodel
      use mo_nad
!!!!!f2py intent(c) theta_v,phi_v,x,wb,x_ad
      implicit none
      integer :: nv,nbands,nl
      integer :: ipt
      double precision,intent(in) :: brff_ad(nbands)
      double precision,intent(out) :: x_ad(rtmodel_nparam)
      double precision :: x(rtmodel_nparam)
      double precision :: theta_v(nv),phi_v(nv),theta_i,phi_i
      double precision :: wb(nbands,nl)
      double precision :: brf_ad(nv,nbands)

      brf_ad(1,:) = brff_ad
      call mo_rtload(x)
      call mo_rtzero_ad()
      call nad_zero()
      call msnadimbrf_ad(ipt,size(wb(:,1)),nl,nv,lad,xkab,xkar,xkw,xkm,xleafn,xs1,xs2,xs3,xs4,theta_i,phi_i,theta_v,phi_v,&
           xhc,xlai,rpl,brf_ad,xlai_ad,xhc_ad,rpl_ad,xkab_ad,xkar_ad,xkw_ad,xkm_ad,xleafn_ad,&
           xs1_ad,xs2_ad,xs3_ad,xs4_ad,wb)
      call mo_rtsum_ad(x_ad)

end subroutine rt_modeld

subroutine rt_getnparams(n)
      use mo_rtmodel
      implicit none
      integer, intent(out) :: n
      n = rtmodel_nparam
end
subroutine rt_getspectralinterval(n)
      use mo_rtmodel
      implicit none
      double precision, intent(out) :: n
      n = rtmodel_spectralInterval
end
subroutine rt_getspectralmin(n)
      use mo_rtmodel
      implicit none
      double precision, intent(out) :: n
      n = rtmodel_spectralMin
end
subroutine rt_getspectralmax(n)
      use mo_rtmodel
      implicit none
      double precision, intent(out) :: n
      n = rtmodel_spectralMax
end

!subroutine rt_setnlmax(n)
!!      use mo_rtmodel
!      use mo_nad
!      implicit none
!      double precision, intent(in) :: n
!      nwmax = n 
!      nwmaxx = n
!end
subroutine rt_getnames(names)
      use mo_rtmodel
      use mo_nad
      implicit none
      character(2000),intent(out) :: names
      names = rtmodel_param_names
end

subroutine rt_getminmax(names)
      use mo_rtmodel
      use mo_nad
      implicit none
      character(2000),intent(out) :: names
      names = rtmodel_param_minmax
end

c                           disclaimer
c
c   this file was generated by taf version 1.9.69
c
c   fastopt disclaims  all  warranties,  eprior_xess  or  implied,
c   including (without limitation) all implied  warranties  of
c   merchantability  or fitness for a particular purpose, with
c   respect to the software and user programs.   in  no  event
c   shall  fastopt be liable for any lost or anticipated prof-
c   its, or any indirect, incidental, exemplary,  special,  or
c   consequential  damages, whether or not fastopt was advised
c   of the possibility of such damages.
c
c                           haftungsbeschraenkung
c   fastopt gibt ausdruecklich keine gewaehr, explizit oder indirekt,
c   bezueglich der brauchbarkeit  der software  fuer einen bestimmten
c   zweck.   unter  keinen  umstaenden   ist  fastopt   haftbar  fuer
c   irgendeinen verlust oder nicht eintretenden erwarteten gewinn und
c   allen indirekten,  zufaelligen,  exemplarischen  oder  speziellen
c   schaeden  oder  folgeschaeden  unabhaengig  von einer eventuellen
c   mitteilung darueber an fastopt.
c
      subroutine archi_ad( x_lai, x_lai_ad, teta_s )
c******************************************************************
c******************************************************************
c** this routine was generated by automatic differentiation.     **
c** fastopt: transformation of algorithm in fortran, taf 1.9.69  **
c******************************************************************
c******************************************************************
c==============================================
c all entries are defined explicitly
c==============================================
      use mo_nad
      implicit none

c==============================================
c declare arguments
c==============================================
      double precision :: teta_s
      double precision :: x_lai(nw)
      double precision :: x_lai_ad(nw)

c locals
      double precision :: tmpr_ad(nw),tmpr(nw),tmpx_ly(nw)
c      print*,'uhu',nw,x_lai_ad,x_lai
c----------------------------------------------
c routine body
c----------------------------------------------
      a_f(1:nw) = (df(1:nw)/2.)**2*pi
      tmpx_ly = x_ly(1:nw)
      call deep(tmpx_ly,teta_s)
      x_ly(1:nw) = tmpx_ly
      tmpr = r(1:nw)
      call sun_fleck(tmpr,teta_s)
      r(1:nw) = tmpr
      h_c_ad(1:nw) = h_c_ad(1:nw)-
     $c1_ad(1:nw)*(2*r*x_lai/(h_c(1:nw)*h_c(1:nw)))
      r_ad(1:nw) = r_ad(1:nw)+c1_ad(1:nw)*(2*x_lai/h_c(1:nw))
      x_lai_ad = x_lai_ad+c1_ad(1:nw)*(2*r/h_c(1:nw))
      c1_ad = 0.
      tmpr_ad = r_ad(1:nw)
      call sun_fleckh_ad( r_ad,teta_s )
      r_ad = 0.
      df_ad(1:nw) = df_ad(1:nw)+a_f_ad(1:nw)*df(1:nw)/2.*pi
      a_f_ad = 0.

      end subroutine archi_ad


      subroutine archi( x_lai, teta_s )
c******************************************************************
c******************************************************************
c** this routine was generated by automatic differentiation.     **
c** fastopt: transformation of algorithm in fortran, taf 1.9.69  **
c******************************************************************
c******************************************************************
c==============================================
c all entries are defined explicitly
c==============================================
      use mo_nad
      implicit none

c==============================================
c declare arguments
c==============================================
      double precision :: teta_s
      double precision :: x_lai(nw),tmpx_ly(nw),tmpr(nw)

      a_f(1:nw) = (df(1:nw)/2.)**2*pi
      x_nf(1:nw) = x_lai/(a_f(1:nw)*h_c(1:nw))
c      print*,'x_nf',x_nf
c      print*,'x_lai',x_lai
      tmpx_ly = x_ly(1:nw)
      call deep(tmpx_ly,teta_s)
      x_ly(1:nw) = tmpx_ly
      tmpr = r(1:nw)
      call sun_fleck(tmpr,teta_s)
      r(1:nw) = tmpr
      c1(1:nw) = 2.*r(1:nw)*x_lai/h_c(1:nw)
      end subroutine archi


      subroutine bunnik( ild1 )
c******************************************************************
c******************************************************************
c** this routine was generated by automatic differentiation.     **
c** fastopt: transformation of algorithm in fortran, taf 1.9.69  **
c******************************************************************
c******************************************************************
c==============================================
c all entries are defined explicitly
c==============================================
      use mo_nad
      implicit none

c==============================================
c declare arguments
c==============================================
      integer :: ild1

      ag = 1.
      bg = 1.
      cg = 1.
      dg = 1.
      if (ild1 .eq. 1) then
        dg = 0.
      endif
      if (ild1 .eq. 2) then
        bg = -1.
        dg = 0.
      endif
      if (ild1 .eq. 3) then
        bg = -1.
        cg = 2.
        dg = 0.
      endif
      if (ild1 .eq. 4) then
        cg = 2.
        dg = 0.
      endif
      if (ild1 .eq. 5) then
        ag = 0.
        bg = 0.
        cg = 0.
      endif
      end subroutine bunnik


      subroutine deep( vdeep, teta_01 )
c******************************************************************
c******************************************************************
c** this routine was generated by automatic differentiation.     **
c** fastopt: transformation of algorithm in fortran, taf 1.9.69  **
c******************************************************************
c******************************************************************
c==============================================
c all entries are defined explicitly
c==============================================
      use mo_nad
      implicit none

c==============================================
c declare arguments
c==============================================
      double precision :: vdeep(nw)
      double precision :: teta_01

c==============================================
c declare local variables
c==============================================
      double precision :: help_h(nw)
      double precision :: x_a(nw)

      x_a = 0.005
      call g_ross(help_h,teta_01)
      vdeep = -(log(x_a)*abs(cos(teta_01))/help_h)
      end  subroutine deep


      subroutine energie( teta_i, phi_i, fpar, albedo_sys, trans_totale 
     $)
c******************************************************************
c******************************************************************
c** this routine was generated by automatic differentiation.     **
c** fastopt: transformation of algorithm in fortran, taf 1.9.69  **
c******************************************************************
c******************************************************************
c==============================================
c all entries are defined explicitly
c==============================================
      use mo_nad
      implicit none

c==============================================
c declare arguments
c==============================================
      double precision :: albedo_sys(nw)
      double precision :: fpar(nw)
      double precision :: phi_i
      double precision :: teta_i
      double precision :: trans_totale(nw)

c==============================================
c declare local variables
c==============================================
      double precision :: g_w(32,nw)
      double precision :: gamma_0(32,32,nw)
      double precision :: gs(nw)
      integer :: i
      integer :: j
      integer :: k
      integer :: m0
      double precision :: mm(32,32,nw)
      integer :: mmm
      double precision :: phi_s(nw)
      double precision :: phi_w(nw)
      double precision :: sum_k(nw)
      double precision :: sum_x(nw)
      double precision :: sum_y(nw)
      double precision :: t_i1d(32,32,nw)
      double precision :: teta_s
      double precision :: teta_w
      double precision :: trans_1(nw)
      double precision :: trans_1_in(nw)
      double precision :: trans_in_m(nw)
      double precision :: trans_m(nw)
      double precision :: x
      double precision :: x_lambda(32,32,nw)
      double precision :: x_lambda_0(nw)
      double precision :: x_rho_0(32,32,nw)
      double precision :: x_rho_1(32,32,nw)
      double precision :: x_rho_m(32,32,nw)
      double precision :: xm
      double precision :: xmus
      double precision :: xr
      double precision :: xt_directe(nw)
      double precision :: y(nw)
      double precision :: ym
      double precision :: yr

      double precision :: g_w_h(nw), gamma_0_h(nw)
      double precision :: x_rho_0_h(nw), x_rho_1_h(nw),x_rho_m_h(nw)

c initialise locals
      g_w=0
      gamma_0=0
      gs=0
      m0=0
      mm=0
      mmm=0
      phi_s=0
      phi_w=0
      sum_k=0
      sum_x=0
      sum_y=0
      t_i1d=0
      teta_s=0
      teta_w=0
      trans_1=0
      trans_1_in=0
      trans_in_m=0
      trans_m=0
      x=0
      x_lambda=0
      x_lambda_0=0
      x_rho_0=0
      x_rho_1=0
      x_rho_m=0
      xm=0
      xmus=0
      xr=0
      xt_directe=0
      y=0
      ym=0
      yr=0
c start code
      teta_s = (180.-teta_i)*pi/180.
      phi_s = (180.-phi_i)*pi/180.
      call g_ross(gs,teta_s)
      xmus = cos(teta_s)
      xm = 0.5*(1.-1.)
      xr = 0.5*(1.+1.)
      ym = 0.5*(2.*pi-0.)
      yr = 0.5*(2.*pi+0.)
      do j = 1, number
        x = xm+xr*points(j)
        teta_w = acos(x)
        call  g_ross(g_w_h,teta_w)
        g_w(j,:) = g_w_h
      end do
      do i = 1, number
        y = ym+yr*points(i)
        phi_w = y
        do j = 1, number
          x = xm+xr*points(j)
          teta_w = acos(x)
          x_lambda(i,j,:) = 0.01*abs(cos(teta_s))/gs*
     $abs(cos(teta_w))/g_w(j,:)
          mm(i,j,:) = lai(1:nw)/x_lambda(i,j,:)
          call rho_0_nad(x_rho_0_h,teta_w,phi_w(1),x_lambda(i,j,:))
          x_rho_0(i,j,:) = x_rho_0_h
          call rho_1_nad(x_rho_1_h,teta_w,phi_w(1),x_lambda(i,j,:))
          x_rho_1(i,j,:) = x_rho_1_h
          call rho_mult_nad(x_rho_m_h,teta_w)
          x_rho_m(i,j,:) = x_rho_m_h
        end do
      end do
      sum_y = 0.
      do i = 1, number
        y = ym+yr*points(i)
        sum_x = 0.
        do j = number/2+1, number
          x = xm+xr*points(j)
          sum_x = sum_x+(x_rho_0(i,j,:)+x_rho_1(i,j,:)
     $+x_rho_m(i,j,:))*weights(j)*abs(x)*xr
        end do
        sum_y = sum_y+sum_x*weights(i)*yr
      end do
      albedo_sys = sum_y/pi
      do i = 1, number
        y = ym+yr*points(i)
        phi_w = y
        do j = 1, number/2
          x = xm+xr*points(j)
          teta_w = acos(x)
          call  gamma_leaf(gamma_0_h,teta_s,phi_s(1),teta_w,phi_w(1))
          gamma_0(i,j,:) = gamma_0_h
        end do
      end do
      do i = 1, number
        y = ym+yr*points(i)
        phi_w = y
        do j = 1, number/2
          x = xm+xr*points(j)
          teta_w = acos(x)
          sum_k = 0
          mmm = mm(i,j,lbound(mm,3))
          do k = 1, mmm
            sum_k = sum_k+(1.-x_lambda(i,j,:)*g_w(j,:)/abs(x))**(mmm-k)*
     $x_lambda(i,j,:)*(1.-x_lambda(i,j,:)*gs/abs(xmus))**k
          end do
          t_i1d(i,j,:) = sum_k*gamma_0(i,j,:)*(1./(pi*abs(x)))
        end do
      end do
      sum_y = 0.
      do i = 1, number
        y = ym+yr*points(i)
        sum_x = 0.
        do j = 1, number/2
          x = xm+xr*points(j)
          sum_x = sum_x+t_i1d(i,j,:)*weights(j)*abs(x)*xr
        end do
        sum_y = sum_y+sum_x*weights(i)*yr
      end do
      trans_1 = sum_y/abs(xmus)
      sum_y = 0.
      do i = 1, number
        y = ym+yr*points(i)
        sum_x = 0.
        do j = 1, number/2
          x = xm+xr*points(j)
          sum_x = sum_x+t_i1d(i,j,:)*rs*weights(j)*abs(x)*xr
        end do
        sum_y = sum_y+sum_x*weights(i)*yr
      end do
      trans_1_in = sum_y/abs(xmus)
      sum_x = 0.
      do j = 1, number/2
        x = xm+xr*points(j)
        sum_x = sum_x+xif(21,j,1:nw)*weights(j)*abs(x)*xr
      end do
      trans_m = sum_x/abs(xmus)
      sum_x = 0.
      do j = number/2+1, number
        x = xm+xr*points(j)
        sum_x = sum_x+ximt(1:nw)*weights(j)*abs(x)*xr
      end do
      trans_in_m = sum_x/abs(xmus)
      x_lambda_0 = 0.01**abs(xmus)/gs*abs(xmus)/gs
      m0 = lai(1)/x_lambda_0(1)
      xt_directe = (1.-x_lambda_0*gs/abs(xmus))**m0
      trans_totale = xt_directe+trans_m+trans_1
      fpar = 1.-albedo_sys-(1.-rs)*trans_totale
      end subroutine energie


      subroutine fase_leafh_ad( fase_leaf_ad, teta_i, teta_e )
c******************************************************************
c******************************************************************
c** this routine was generated by automatic differentiation.     **
c** fastopt: transformation of algorithm in fortran, taf 1.9.69  **
c******************************************************************
c******************************************************************
c==============================================
c all entries are defined explicitly
c==============================================
      use mo_nad
      implicit none

c==============================================
c declare arguments
c==============================================
      double precision, intent(inout) :: fase_leaf_ad(nw)
      double precision :: teta_e
      double precision :: teta_i

c==============================================
c declare local variables
c==============================================
      double precision :: help_h(nw)
      double precision :: help_i(nw)
      double precision :: help_j(nw)
      integer :: j
      double precision :: sum_ad(nw)
      double precision :: x
      double precision :: xm
      double precision :: xr
c initialise locals
      help_h=0
      help_i=0
      help_j=0
      j=0
      x=0
      xm=0
      xr=0
c----------------------------------------------
c reset local adjoint variables
c----------------------------------------------
      sum_ad = 0.

c----------------------------------------------
c routine body
c----------------------------------------------
      xm = 0.5*(pi/2.+0.)
      xr = 0.5*(pi/2.-0.)
      sum_ad = sum_ad+fase_leaf_ad*xr
      fase_leaf_ad = 0.
      do j = 1, number
        x = xm+xr*points(j)
        call  gl_bun(help_h,x)
        call psi_leaf_p(help_i,teta_e,teta_i,x)
        call psi_leaf_m(help_j,teta_e,teta_i,x)
        rl_ad(1:nw) = rl_ad(1:nw)+sum_ad*weights(j)*help_h*help_j
        tl_ad(1:nw) = tl_ad(1:nw)+sum_ad*weights(j)*help_h*help_i
      end do

      end subroutine fase_leafh_ad


      subroutine fase_leaf( vfase_leaf, teta_i, teta_e )
c******************************************************************
c******************************************************************
c** this routine was generated by automatic differentiation.     **
c** fastopt: transformation of algorithm in fortran, taf 1.9.69  **
c******************************************************************
c******************************************************************
c==============================================
c all entries are defined explicitly
c==============================================
      use mo_nad
      implicit none

c==============================================
c declare arguments
c==============================================
      double precision :: vfase_leaf(nw)
      double precision :: teta_e
      double precision :: teta_i

c==============================================
c declare local variables
c==============================================
      double precision :: help_h(nw)
      double precision :: help_i(nw)
      double precision :: help_j(nw)
      integer :: j
      double precision :: sum(nw)
      double precision :: x
      double precision :: xm
      double precision :: xr
c initialise locals
      help_h=0
      help_i=0
      help_j=0
      j=0
      x=0
      xm=0
      xr=0

      xm = 0.5*(pi/2.+0.)
      xr = 0.5*(pi/2.-0.)
      sum = 0.
      do j = 1, number
        x = xm+xr*points(j)
        call gl_bun(help_h,x)
        call psi_leaf_p(help_i,teta_e,teta_i,x)
        call psi_leaf_m(help_j,teta_e,teta_i,x)
        sum = sum+weights(j)*help_h*(tl(1:nw)*help_i+rl(1:nw)*help_j)
      end do
      vfase_leaf = sum*xr
      end subroutine fase_leaf


      subroutine fg_ross( vfg_ross, teta_p, x )
c******************************************************************
c******************************************************************
c** this routine was generated by automatic differentiation.     **
c** fastopt: transformation of algorithm in fortran, taf 1.9.69  **
c******************************************************************
c******************************************************************
c==============================================
c all entries are defined explicitly
c==============================================
      use mo_nad
      implicit none

c==============================================
c declare arguments
c==============================================
      double precision :: vfg_ross(nw)
      double precision :: teta_p
      double precision :: x

c==============================================
c declare local variables
c==============================================
      double precision :: help_h(nw)
      double precision :: help_i(nw)
      double precision :: teta_i
c initialise locals
      help_h=0
      help_i=0

      teta_i = teta_p
      call gl_bun(help_h,x)
      call psi_ross(help_i,teta_i,x)
      vfg_ross = help_h*help_i
      end subroutine fg_ross


      subroutine fgamma_leafh_ad( fgamma_leaf_ad, teta_p, phi_p, x, y, 
     $teta_i, phi_i )
c******************************************************************
c******************************************************************
c** this routine was generated by automatic differentiation.     **
c** fastopt: transformation of algorithm in fortran, taf 1.9.69  **
c******************************************************************
c******************************************************************
c==============================================
c all entries are defined explicitly
c==============================================
      use mo_nad
      implicit none

c==============================================
c declare arguments
c==============================================
      double precision, intent(inout) :: fgamma_leaf_ad(nw)
      double precision :: phi_i
      double precision :: phi_p
      double precision :: teta_i
      double precision :: teta_p
      double precision :: x
      double precision :: y

c==============================================
c declare local variables
c==============================================
      double precision :: di
      double precision :: dp
      double precision :: dpp
      double precision :: f_ad(nw)
      double precision :: g1(nw)
c initialise locals
      di=0
      dp=0
      dpp=0
      g1=0
c----------------------------------------------
c reset local adjoint variables
c----------------------------------------------
      f_ad = 0.

c----------------------------------------------
c routine body
c----------------------------------------------
      call gl_bun(g1,x)
      dp = cos(x)*cos(teta_i)+sin(x)*sin(teta_i)*cos(abs(phi_i-y))
      dpp = cos(x)*cos(teta_p)+sin(x)*sin(teta_p)*cos(abs(phi_p-y))
      di = dp*dpp
      f_ad = f_ad+fgamma_leaf_ad*g1/pi*abs(dp)*abs(dpp)
      fgamma_leaf_ad = 0.
      if (di .lt. 0.) then
        rl_ad(1:nw) = rl_ad(1:nw)+f_ad
        f_ad = 0.
      else
        tl_ad(1:nw) = tl_ad(1:nw)+f_ad
        f_ad = 0.
      endif

      end subroutine fgamma_leafh_ad


      subroutine fgamma_leaf( vfgamma_leaf, 
     $teta_p, phi_p, x, y, teta_i, phi_i )
c******************************************************************
c******************************************************************
c** this routine was generated by automatic differentiation.     **
c** fastopt: transformation of algorithm in fortran, taf 1.9.69  **
c******************************************************************
c******************************************************************
c==============================================
c all entries are defined explicitly
c==============================================
      use mo_nad
      implicit none

c==============================================
c declare arguments
c==============================================
      double precision :: vfgamma_leaf(nw)
      double precision :: phi_i
      double precision :: phi_p
      double precision :: teta_i
      double precision :: teta_p
      double precision :: x
      double precision :: y

c==============================================
c declare local variables
c==============================================
      double precision :: di
      double precision :: dp
      double precision :: dpp
      double precision :: f(nw)
      double precision :: g1(nw)
c initialise locals
      di=0
      dp=0
      dpp=0
      f=0
      g1=0
c start code
      call gl_bun(g1,x)
      dp = cos(x)*cos(teta_i)+sin(x)*sin(teta_i)*cos(abs(phi_i-y))
      dpp = cos(x)*cos(teta_p)+sin(x)*sin(teta_p)*cos(abs(phi_p-y))
      di = dp*dpp
      if (di .lt. 0.) then
        f = rl(1:nw)
      else
        f = tl(1:nw)
      endif
      vfgamma_leaf = g1*f/pi*abs(dp)*abs(dpp)
      end subroutine fgamma_leaf


      subroutine g_ross(vg_ross, teta_p )
c******************************************************************
c******************************************************************
c** this routine was generated by automatic differentiation.     **
c** fastopt: transformation of algorithm in fortran, taf 1.9.69  **
c******************************************************************
c******************************************************************
c==============================================
c all entries are defined explicitly
c==============================================
      use mo_nad
      implicit none

c==============================================
c declare arguments
c==============================================
      double precision :: vg_ross(nw)
      double precision :: teta_p

c==============================================
c declare local variables
c==============================================
      double precision :: a
      double precision :: b
      double precision :: dx
      integer :: i
      double precision :: ssc(nw)
      double precision :: x1(nw)
      double precision :: x2(nw)
      double precision :: xm
      double precision :: xr
c initialise locals
      a=0
      b=0
      dx=0
      i=0
      x1=0
      x2=0
      xm=0
      xr=0
      ssc = 0.
      a = 0.
      b = pi/2.
      xm = 0.5*(b+a)
      xr = 0.5*(b-a)
      do i = number/2+1, number
        dx = xr*points(i)
        call fg_ross(x1,teta_p,xm+dx)
        call fg_ross(x2,teta_p,xm-dx)
        ssc = ssc+weights(i)*(x1+x2)
      end do
      ssc = ssc*xr
      vg_ross = ssc
      end  subroutine g_ross


      subroutine gamma_leafh_ad( gamma_leaf_ad, teta_p, phi_p, teta_i, 
     $phi_i )
c******************************************************************
c******************************************************************
c** this routine was generated by automatic differentiation.     **
c** fastopt: transformation of algorithm in fortran, taf 1.9.69  **
c******************************************************************
c******************************************************************
c==============================================
c all entries are defined explicitly
c==============================================
      use mo_nad
      implicit none

c==============================================
c declare arguments
c==============================================
      double precision, intent(inout) :: gamma_leaf_ad(nw)
      double precision :: phi_i
      double precision :: phi_p
      double precision :: teta_i
      double precision :: teta_p

c==============================================
c declare local variables
c==============================================
      double precision :: dx
      double precision :: dy
      double precision :: gausg_ad(nw)
      integer :: i
      integer :: j
      double precision :: sd_ad(nw)
      double precision :: sy_ad(nw)
      double precision :: xm
      double precision :: xr
      double precision :: ym
      double precision :: yr
c initialise locals
      dx=0
      dy=0
      i=0
      j=0
      xm=0
      xr=0
      ym=0
      yr=0
c----------------------------------------------
c reset local adjoint variables
c----------------------------------------------
      gausg_ad = 0.
      sd_ad = 0.
      sy_ad = 0.

c----------------------------------------------
c routine body
c----------------------------------------------
      xm = 0.5*(pi/2.+0.)
      xr = 0.5*(pi/2.-0.)
      ym = 0.5*(2.*pi+0.)
      yr = 0.5*(2.*pi-0.)
      gausg_ad = gausg_ad+0.5*gamma_leaf_ad
      gamma_leaf_ad = 0.
      do j = number, 1, -1
        sd_ad = 0.
        sy_ad = 0.
        dx = xm+xr*points(j)
        sy_ad = sy_ad+gausg_ad*weights(j)*yr
        do i = number, 1, -1
          sd_ad = 0.
          dy = ym+yr*points(i)
          sd_ad = sd_ad+sy_ad*weights(i)*xr
          call fgamma_leafh_ad( sd_ad,teta_p,phi_p,dx,dy,teta_i,phi_i )
          sd_ad = 0.
        end do
        sy_ad = 0.
      end do

      end subroutine gamma_leafh_ad


      subroutine gamma_leaf( vgamma_leaf,
     $teta_p, phi_p, teta_i, phi_i )
c******************************************************************
c******************************************************************
c** this routine was generated by automatic differentiation.     **
c** fastopt: transformation of algorithm in fortran, taf 1.9.69  **
c******************************************************************
c******************************************************************
c==============================================
c all entries are defined explicitly
c==============================================
      use mo_nad
      implicit none

c==============================================
c declare arguments
c==============================================
      double precision :: vgamma_leaf(nw)
      double precision :: phi_i
      double precision :: phi_p
      double precision :: teta_i
      double precision :: teta_p

c==============================================
c declare local variables
c==============================================
      double precision :: dx
      double precision :: dy
      double precision :: gausg(nw)
      integer :: i
      integer :: j
      double precision :: sd(nw)
      double precision :: sy(nw)
      double precision :: xm
      double precision :: xr
      double precision :: ym
      double precision :: yr
c initialise locals
      dx=0
      dy=0
      gausg=0
      i=0
      j=0
      sd=0
      sy=0
      xm=0
      xr=0
      ym=0
      yr=0
c code body
      xm = 0.5*(pi/2.+0.)
      xr = 0.5*(pi/2.-0.)
      ym = 0.5*(2.*pi+0.)
      yr = 0.5*(2.*pi-0.)
      gausg = 0.
      do j = 1, number
        dx = xm+xr*points(j)
        sy = 0.
        do i = 1, number
          dy = ym+yr*points(i)
          call fgamma_leaf(sd,teta_p,phi_p,dx,dy,teta_i,phi_i)
          sy = sy+weights(i)*sd*xr
        end do
        gausg = gausg+weights(j)*sy*yr
      end do
      vgamma_leaf = gausg/2.
      end subroutine gamma_leaf


      subroutine gauleg( x1, x2, x, w, n )
c******************************************************************
c******************************************************************
c** this routine was generated by automatic differentiation.     **
c** fastopt: transformation of algorithm in fortran, taf 1.9.69  **
c******************************************************************
c******************************************************************
c==============================================
c all entries are defined explicitly
c==============================================
      use mo_nad
      implicit none
      double precision eps
c==============================================
c declare arguments
c==============================================
      integer :: n
      double precision :: w(n)
      double precision :: x(n)
      double precision :: x1
      double precision :: x2

c==============================================
c declare local variables
c==============================================
      integer :: i
      integer :: j
      integer :: m
      double precision :: p1
      double precision :: p2
      double precision :: p3
      double precision :: pp
      double precision :: xl
      double precision :: xm
      double precision :: z
      double precision :: z1
c initialise locals
      i=0
      j=0
      m=0
      p1=0
      p2=0
      p3=0
      pp=0
      xl=0
      xm=0
      z=0
      z1=0
c code body
      eps = 3.d-14
      m = (n+1)/2
      xm = 0.5d0*(x2+x1)
      xl = 0.5d0*(x2-x1)
cdummy loop header
      do i = 1, m
        z = cos(3.141592654d0*(i-0.25d0)/(n+0.5d0))
        p1 = 1.d0
        p2 = 0.d0
        do j = 1, n
          p3 = p2
          p2 = p1
          p1 = ((2.d0*j-1.d0)*z*p2-(j-1.d0)*p3)/j
        end do
        pp = n*(z*p1-p2)/(z*z-1.d0)
        z1 = z
        z = z1-p1/pp
        do while ( abs(z-z1) .gt. eps )
          p1 = 1.d0
          p2 = 0.d0
          do j = 1, n
            p3 = p2
            p2 = p1
            p1 = ((2.d0*j-1.d0)*z*p2-(j-1.d0)*p3)/j
          end do
          pp = n*(z*p1-p2)/(z*z-1.d0)
          z1 = z
          z = z1-p1/pp
        end do
        x(i) = xm-xl*z
        x(n+1-i) = xm+xl*z
        w(i) = 2.d0*xl/((1.d0-z*z)*pp*pp)
        w(n+1-i) = w(i)
      end do
      end subroutine gauleg


      subroutine geo( vgeo,teta_e, teta_01, phi_e, phi_01 )
c******************************************************************
c******************************************************************
c** this routine was generated by automatic differentiation.     **
c** fastopt: transformation of algorithm in fortran, taf 1.9.69  **
c******************************************************************
c******************************************************************
c==============================================
c all entries are defined explicitly
c==============================================
      use mo_nad
      implicit none

c==============================================
c declare arguments
c==============================================
      double precision :: vgeo(nw)
      double precision :: phi_01
      double precision :: phi_e
      double precision :: teta_01
      double precision :: teta_e

c==============================================
c declare local variables
c==============================================
      double precision :: li1
      double precision :: li2

      li1 = tan(teta_01)**2+tan(teta_e)**2
      li2 = -(2.*tan(teta_e)*tan(teta_01)*cos(phi_01-phi_e))
      vgeo = sqrt(abs(li1+li2))
      where (vgeo .lt. 9.9999999999999e-36) vgeo = 9.9999999999999e-36
      end subroutine geo


      subroutine gl_bun(vgl_bun, x )
c******************************************************************
c******************************************************************
c** this routine was generated by automatic differentiation.     **
c** fastopt: transformation of algorithm in fortran, taf 1.9.69  **
c******************************************************************
c******************************************************************
c==============================================
c all entries are defined explicitly
c==============================================
      use mo_nad
      implicit none

c==============================================
c declare arguments
c==============================================
      double precision :: vgl_bun(nw)
      double precision :: x

      vgl_bun = 2./pi*(ag+bg*cos(2.*cg*x))+dg*sin(x)
      end subroutine gl_bun


      subroutine hot_spoth_ad( hot_spot_ad, x, x_ad, xli, xli_ad )
c******************************************************************
c******************************************************************
c** this routine was generated by automatic differentiation.     **
c** fastopt: transformation of algorithm in fortran, taf 1.9.69  **
c******************************************************************
c******************************************************************
c==============================================
c all entries are defined explicitly
c==============================================
      use mo_nad
      implicit none

c==============================================
c declare arguments
c==============================================
      double precision, intent(inout) :: hot_spot_ad(nw)
      double precision :: x(nw)
      double precision :: x_ad(nw)
      double precision :: xli(nw)
      double precision :: xli_ad(nw)

c----------------------------------------------
c routine body
c----------------------------------------------
      where (x .lt. xli) 
        x_ad = x_ad+hot_spot_ad*((1.-4./(3.*pi))/xli)
        xli_ad = xli_ad-hot_spot_ad*((1.-4./(3.*pi))*x/(xli*xli))
        hot_spot_ad = 0.
      end where
      where (x .ge. xli)
        x_ad = x_ad+hot_spot_ad*(4./(3.*pi)*xli/(x*x))
        xli_ad = xli_ad-hot_spot_ad*(4./(3.*pi)/x)
        hot_spot_ad = 0.
      end where

      end subroutine hot_spoth_ad


      subroutine hot_spot(vhot_spot, x, xli )
c******************************************************************
c******************************************************************
c** this routine was generated by automatic differentiation.     **
c** fastopt: transformation of algorithm in fortran, taf 1.9.69  **
c******************************************************************
c******************************************************************
c==============================================
c all entries are defined explicitly
c==============================================
      use mo_nad
      implicit none

c==============================================
c declare arguments
c==============================================
      double precision :: vhot_spot(nw)
      double precision :: x(nw)
      double precision :: xli(nw)

      where (x .lt. xli) 
        vhot_spot = (1.-4./(3.*pi))*x/xli
      end where
      where (x .ge. xli )
        vhot_spot = 1.-4./(3.*pi)*xli/x
      end where
      end subroutine hot_spot

      subroutine multiple_dom_ad( ipt,teta_01 )
c******************************************************************
c******************************************************************
c** this routine was generated by automatic differentiation.     **
c** fastopt: transformation of algorithm in fortran, taf 1.9.69  **
c******************************************************************
c******************************************************************
c==============================================
c referencing used modules
c==============================================
      use mo_nad
      use multiple_dom_store_ad

c==============================================
c all entries are defined explicitly
c==============================================
      use mo_nad
      implicit none

c==============================================
c declare arguments
c==============================================
      double precision :: teta_01
      integer :: ipt
c==============================================
c declare local variables
c==============================================
      double precision :: dl(nw)
      double precision :: dl_ad(nw)
      double precision :: g0(nw)
      double precision :: gg(40,nw)
      integer :: i
      double precision :: i00(nw)
      double precision :: i0h(nw)
      double precision :: i0h_ad(nw)
      double precision :: i0i(nw)
      integer :: j
      integer :: k
      integer :: l
      integer :: m
      integer :: nl
      double precision :: q0m(21,40,nw)
      double precision :: q0m_ad(21,40,nw)
      double precision :: q1(21,40,nw)
      double precision :: q1_ad(21,40,nw)
      double precision :: s(21,40,nw)
      double precision :: s_ad(21,40,nw)
      double precision :: sum(nw)
      double precision :: sum_ad(nw)
      double precision :: x
      double precision :: xgama_0(40,nw)
      double precision :: xgama_0_ad(40,nw)
      double precision :: xgama_xy(40,40,nw)
      double precision :: xgama_xy_ad(40,40,nw)
      double precision :: xi(21,40,nw)
      double precision :: xi1uh(nw)
      double precision :: xi1ui(nw)
      double precision :: xi1ui_ad(nw)
      double precision :: xi1uj(nw)
      double precision :: xi1uk(nw)
      double precision :: xi1ul(nw)
      double precision :: xi1um(nw)
      double precision :: xi_ad(21,40,nw)
      double precision :: xih(nw)
      double precision :: xii(nw)
      double precision :: xii_ad(nw)
      double precision :: xij(nw)
      double precision :: xik(nw)
      double precision :: xil(nw)
      double precision :: xim(nw)
      double precision :: xl(nw)
      double precision :: xl_ad(nw)
      double precision :: xm
      double precision :: xmu0
      double precision :: xr
      double precision :: y(nw)

      double precision :: xgama_xy_h(nw),xgama_0_h(nw)
      double precision :: gg_h(nw)
c initialise locals
      dl=0
      g0=0
      gg=0
      i=0
      i00=0
      i0h=0
      i0h_ad=0
      i0i=0
      j=0
      k=0
      l=0
      m=0
      nl=0
      q0m=0
      q1=0
      s=0
      sum=0
      x=0
      xgama_0=0
      xgama_xy=0
      xi=0
      xi1uh=0
      xi1ui=0
      xi1ui_ad=0
      xi1uj=0
      xi1uk=0
      xi1ul=0
      xi1um=0
      xih=0
      xii=0
      xii_ad=0
      xij=0
      xik=0
      xil=0
      xim=0
      xl=0
      xm=0
      xmu0=0
      xr=0
      y=0
      xgama_xy_h=0
      xgama_0_h=0
      gg_h=0

c----------------------------------------------
c reset local adjoint variables
c----------------------------------------------
      dl_ad = 0.
      q0m_ad = 0.
      q1_ad = 0.
      s_ad = 0.
      sum_ad = 0.
      xgama_0_ad = 0.
      xgama_xy_ad = 0.
      xi_ad = 0.
      xl_ad = 0.

c----------------------------------------------
c routine body
c----------------------------------------------
      xmu0 = abs(cos(teta_01))
      m = 20
      dl = lai(1:nw)/float(m)
      call g_ross(g0,teta_01)
      xm = 0.5*(1.+(-1.))
      xr = 0.5*(1.-(-1.))
      i00 = 1.
      do j = 1, number
        x = xm+xr*points(j)
        call g_ross(gg_h,acos(x))
        gg(j,:) = gg_h
      end do
      xi = 0.
      do k = 1, m+1
        xl = float(k-1)*dl
        do i = 1, number/2
          x = xm+xr*points(i)
          if (abs(x) .eq. xmu0) then
            i0(k,i,1:nw) = i00*exp(-(g0/xmu0*xl))
          else
            i0(k,i,1:nw) = 0.
          endif
        end do
      end do
      do k = m+1, 1, -1
        xl = float(k-1)*dl
        do i = number/2+1, number
          x = xm+xr*points(i)
          i0(k,i,1:nw) = 2.*rs*i00*xmu0*exp(-((g0/xmu0)*lai(1:nw)))
     $*exp(-((gg(i,:)/x)*(lai(1:nw)-xl)))
        end do
      end do
      do i = 1, number
        y = xm+xr*points(i)
        do j = 1, number
          x = xm+xr*points(j)
          call fase_leaf(xgama_xy_h,acos(x),acos(y(1)))
          xgama_xy(i,j,:) = xgama_xy_h
        end do
      end do
      do k = m, 1, -1
        do i = 1, number
          sum = 0.
          do j = number/2+1, number
            sum = sum+weights(j)*xr*2.*xgama_xy(i,j,:)
     $*(i0(k+1,j,1:nw)+i0(k,j,1:nw))/2.
          end do
          q0m(k,i,:) = sum
        end do
      end do
      do i = 1, number
        x = xm+xr*points(i)
        call fase_leaf(xgama_0_h,teta_01,acos(x))
        xgama_0(i,:) = xgama_0_h
      end do
      do k = 1, m+1
        xl = float(k-1)*dl
        do j = 1, number/2
          x = xm+xr*points(j)
          if (abs(x) .ne. xmu0) then
	print*,'666',i00,xgama_0(j,:),xmu0,g0,xmu0,xl,exp(-(g0/xmu0*xl))
	    print*,'667',gg(j,:),
     $exp(-(gg(j,:)/abs(x)*xl)),(gg(j,:)*xmu0-g0*abs(x))
            xi(k,j,:) = 
     $i00*2.*xgama_0(j,:)*xmu0*(exp(-(g0/xmu0*xl))-exp(-(
     $gg(j,:)/abs(x)*xl)))/(gg(j,:)*xmu0-g0*abs(x))
          else
	    print*,'777',i00,xl,xgama_0(j,:),exp(-(g0/xmu0*xl)),xmu0
            xi(k,j,:) = i00*xl*2.*xgama_0(j,:)*exp(-(g0/xmu0*xl))/xmu0
          endif
        end do
      end do
      do k = m+1, 1, -1
        xl = float(k-1)*dl
        do j = number/2+1, number
          x = xm+xr*points(j)
	  print*,'999',i00,xgama_0(j,:),xmu0,exp(-(g0/xmu0*xl))
	  print*,'1000',exp(-(gg(j,:)/x*(lai(1:nw)-xl)))
	  print*,'1001',exp(-(g0/xmu0*lai(1:nw))),(g0*x+gg(j,:)*xmu0)
          xi(k,j,:) = 
     $i00*2.*xgama_0(j,:)*xmu0*(exp(-(g0/xmu0*xl))-exp(-(gg(
     $j,:)/x*(lai(1:nw)-xl)))*
     $exp(-(g0/xmu0*lai(1:nw))))/(g0*x+gg(j,:)*xmu0)
        end do
      end do
      do j = number/2+1, number
        xi(m+1,j,:) = 0.
      end do
      do k = 1, m
        do i = 1, number
          sum = 0.
          do j = 1, number
            sum = sum+weights(j)*xr*2.*xgama_xy(i,j,:)
     $*(xi(k+1,j,:)+xi(k,j,:))/2.
          end do
          q1(k,i,:) = sum
        end do
      end do
      nl = nlm
      do l = nl, 1, -1
        s = multl_s_3h(:,:,l+nlm*(ipt-1),:)
        xi = multl_xi_4h(:,:,l+nlm*(ipt-1),:)
        do k = m, 1, -1
          sum_ad = 0.
          do i = number, 1, -1
            sum_ad = 0.
            sum_ad = sum_ad+s_ad(k,i,:)
            s_ad(k,i,:) = 0.
            do j = number, 1, -1
              xgama_xy_ad(i,j,:) = xgama_xy_ad(i,j,:)+
     $sum_ad*(2*weights(j)*
     $xr*(xi(k+1,j,:)+xi(k,j,:))/2.)
              xi_ad(k+1,j,:) = xi_ad(k+1,j,:)+
     $sum_ad*(2*weights(j)*xr*
     $xgama_xy(i,j,:)/2.)
              xi_ad(k,j,:) = xi_ad(k,j,:)+
     $sum_ad*(2*weights(j)*xr*xgama_xy(i,j,:)/2.)
            end do
            sum_ad = 0.
          end do
        end do
        do k = 1, m+1
          do j = 1, number
            xi_ad(k,j,:) = xi_ad(k,j,:)+xif_ad(k,j,1:nw)
            xif_ad(k,j,:) = 0.
          end do
        end do
        do k = 1, m
          xi(k+1,:,:) = multkl_xi_2h(:,k+21*(l-1)+21*nlm*(ipt-1),:)
          do j = number/2+1, number
            x = xm+xr*points(j)
            dl_ad = dl_ad+xi_ad(k,j,:)*((-(xi(k+1,j,:)
     $*(x/(dl*dl))/(gg(j,:)/
     $2.+x/dl)))+(s(k,j,:)+q0m(k,j,:)+q1(k,j,:)-xi(k+1,j,:)*
     $(gg(j,:)/2.-x/dl))*(x/
     $(dl*dl))/((gg(j,:)/2.+x/dl)*(gg(j,:)/2.+x/dl)))
            q0m_ad(k,j,:) = q0m_ad(k,j,:)+xi_ad(k,j,:)/(gg(j,:)/2.+x/dl)
            q1_ad(k,j,:) = q1_ad(k,j,:)+xi_ad(k,j,:)/(gg(j,:)/2.+x/dl)
            s_ad(k,j,:) = s_ad(k,j,:)+xi_ad(k,j,:)/(gg(j,:)/2.+x/dl)
            xi_ad(k+1,j,:) = xi_ad(k+1,j,:)
     $-xi_ad(k,j,:)*((gg(j,:)/2.-x/dl)/(gg(j,:)/2.+x/dl))
            xi_ad(k,j,:) = 0.
          end do
        end do
        do j = number/2+1, number
          xi1_ad(1:nw) = xi1_ad(1:nw)+xi_ad(m+1,j,:)
          ximt_ad(1:nw) = ximt_ad(1:nw)+xi_ad(m+1,j,:)
          xi_ad(m+1,j,:) = 0.
        end do
        xi = multl_xi_2h(:,:,l+nlm*(ipt-1),:)
        do j = 1, number/2
          x = xm+xr*points(j)
          rs_ad(1:nw) = rs_ad(1:nw)+
     $2*ximt_ad(1:nw)*weights(j)*xr*xi(m+1,j,:)*abs(x)
          xi_ad(m+1,j,:) = xi_ad(m+1,j,:)+2.*ximt_ad(1:nw)*
     $weights(j)*xr*rs*abs(x)
        end do
        ximt_ad = 0.
        s = multl_s_1h(:,:,l+nlm*(ipt-1),:)
        do k = m, 1, -1
          xi(k,:,:) = multkl_xi_1h(:,k+21*(l-1)+21*nlm*(ipt-1),:)
          do j = 1, number/2
            x = xm+xr*points(j)
            dl_ad = dl_ad+xi_ad(k+1,j,:)*(xi(k,j,:)*(x/(dl*dl))/
     $(gg(j,:)/2.-x/dl)-(s(k,j,:)+q0m(k,j,:)+q1(k,j,:)-xi(k,j,:)*
     $(gg(j,:)/2.+x/dl))*(x/(dl*dl))/
     $((gg(j,:)/2.-x/dl)*(gg(j,:)/2.-x/dl)))
            q0m_ad(k,j,:) = q0m_ad(k,j,:)+xi_ad(k+1,j,:)/
     $(gg(j,:)/2.-x/dl)
            q1_ad(k,j,:) = q1_ad(k,j,:)+xi_ad(k+1,j,:)/(gg(j,:)/2.-x/dl)
            s_ad(k,j,:) = s_ad(k,j,:)+xi_ad(k+1,j,:)/(gg(j,:)/2.-x/dl)
            xi_ad(k,j,:) = xi_ad(k,j,:)-xi_ad(k+1,j,:)*((gg(j,:)
     $/2.+x/dl)/(gg(j,:)/2.-x/dl))
            xi_ad(k+1,j,:) = 0.
          end do
        end do
      end do
      do k = 1, m+1
        do j = 1, number/2
          xi_ad(k,j,:) = 0.
        end do
      end do
      xi = 0.
      do k = 1, m+1
        xl = float(k-1)*dl
        do j = 1, number/2
          x = xm+xr*points(j)
          if (abs(x) .ne. xmu0) then
            xi(k,j,:) = i00*2.*xgama_0(j,:)
     $*xmu0*(exp(-(g0/xmu0*xl))-exp(-(
     $gg(j,:)/abs(x)*xl)))/(gg(j,:)*xmu0-g0*abs(x))
          else
            xi(k,j,:) = i00*xl*2.*xgama_0(j,:)*exp(-(g0/xmu0*xl))/xmu0
          endif
        end do
      end do
      do k = m+1, 1, -1
        xl = float(k-1)*dl
        do j = number/2+1, number
          x = xm+xr*points(j)
          xi(k,j,:) = i00*2.*xgama_0(j,:)*xmu0
     $*(exp(-(g0/xmu0*xl))-exp(-(gg(j,:)/x*(lai(1:nw)-xl)))*
     $exp(-(g0/xmu0*lai(1:nw))))/(g0*x+gg(j,:)*xmu0)
        end do
      end do
      do j = number/2+1, number
        xi(m+1,j,:) = 0.
      end do
      do k = m, 1, -1
        sum_ad = 0.
        do i = number, 1, -1
          sum_ad = 0.
          sum_ad = sum_ad+q1_ad(k,i,:)
          q1_ad(k,i,:) = 0.
          do j = number, 1, -1
            xgama_xy_ad(i,j,:) = xgama_xy_ad(i,j,:)+
     $sum_ad*(2*weights(j)*xr*
     $(xi(k+1,j,:)+xi(k,j,:))/2.)
            xi_ad(k+1,j,:) = xi_ad(k+1,j,:)+sum_ad*(2*weights(j)*xr*
     $xgama_xy(i,j,:)/2.)
            xi_ad(k,j,:) = xi_ad(k,j,:)+sum_ad*(2*weights(j)*xr*
     $xgama_xy(i,j,:)/2.)
          end do
          sum_ad = 0.
        end do
      end do
      do j = number/2+1, number
        xi1u_ad(m+1,j,:) = 0.
        xi_ad(m+1,j,:) = 0.
      end do
      do k = 1, m+1
        xl_ad = 0.
        xl = float(k-1)*dl
        do j = number/2+1, number
          x = xm+xr*points(j)
          xi1uh = -(g0/xmu0*lai(1:nw))
          xi1ui = -(gg(j,:)/x*(lai(1:nw)-xl))
          xi1uj = -(g0/xmu0*xl)
          xgama_0_ad(j,:) = xgama_0_ad(j,:)+xi1u_ad(k,j,1:nw)
     $*(2*i00*xmu0*(exp(
     $xi1uj)-exp(xi1ui)*exp(xi1uh))/(g0*x+gg(j,:)*xmu0))
          xi1ui_ad = -(xi1u_ad(k,j,1:nw)*(2.*i00*xgama_0(j,:)
     $*xmu0*exp(xi1ui)*
     $exp(xi1uh)/(g0*x+gg(j,:)*xmu0)))
          xl_ad = xl_ad-xi1u_ad(k,j,1:nw)*2.*i00*xgama_0(j,:)*xmu0*
     $exp(xi1uj)/(g0*x+gg(j,:)*xmu0)*(g0/xmu0)
          lai_ad(1:nw) = lai_ad(1:nw)-xi1ui_ad*(gg(j,:)/x)
          xl_ad = xl_ad+xi1ui_ad*(gg(j,:)/x)
          lai_ad(1:nw) = lai_ad(1:nw)+
     $xi1u_ad(k,j,1:nw)*2.*i00*xgama_0(j,:)*
     $xmu0*exp(xi1ui)
     $*exp(xi1uh)/(g0*x+gg(j,:)*xmu0)*(g0/xmu0)
          xi1u_ad(k,j,:) = 0.
          xih = -(g0/xmu0*lai(1:nw))
          xii = -(gg(j,:)/x*(lai(1:nw)-xl))
          xij = -(g0/xmu0*xl)
          xgama_0_ad(j,:) = xgama_0_ad(j,:)+xi_ad(k,j,:)
     $*(2*i00*xmu0*(exp(xij)
     $-exp(xii)*exp(xih))/(g0*x+gg(j,:)*xmu0))
          xii_ad = -(xi_ad(k,j,:)*(2.*i00*xgama_0(j,:)*
     $xmu0*exp(xii)*exp(
     $xih)/(g0*x+gg(j,:)*xmu0)))
          xl_ad = xl_ad-xi_ad(k,j,:)*2.*i00*xgama_0(j,:)*
     $xmu0*exp(xij)/(g0*
     $x+gg(j,:)*xmu0)*(g0/xmu0)
          lai_ad(1:nw) = lai_ad(1:nw)-xii_ad*(gg(j,:)/x)
          xl_ad = xl_ad+xii_ad*(gg(j,:)/x)
          lai_ad(1:nw) = lai_ad(1:nw)+xi_ad(k,j,:)*2.*i00*xgama_0(j,:)
     $*xmu0*exp(xii)*
     $exp(xih)/(g0*x+gg(j,:)*xmu0)*(g0/xmu0)
          xi_ad(k,j,:) = 0.
        end do
        dl_ad = dl_ad+xl_ad*float(k-1)
        xl_ad = 0.
      end do
      xi = 0.
      do k = 1, m+1
        xl = float(k-1)*dl
        do j = 1, number/2
          x = xm+xr*points(j)
          if (abs(x) .ne. xmu0) then
            xi(k,j,:) = i00*2.*xgama_0(j,:)
     $*xmu0*(exp(-(g0/xmu0*xl))-exp(-(
     $gg(j,:)/abs(x)*xl)))/(gg(j,:)*xmu0-g0*abs(x))
          else
            xi(k,j,:) = i00*xl*2.*xgama_0(j,:)*exp(-(g0/xmu0*xl))/xmu0
          endif
        end do
      end do
      do j = 1, number/2
        x = xm+xr*points(j)
        rs_ad(1:nw) = rs_ad(1:nw)+
     $2*xi1_ad(1:nw)*weights(j)*xr*xi(m+1,j,:)*abs(x)
        xi_ad(m+1,j,:) = xi_ad(m+1,j,:)+
     $2*xi1_ad(1:nw)*weights(j)*xr*rs*abs(x)
      end do
      xi1_ad = 0.
      do k = m+1, 1, -1
        xl_ad = 0.
        xl = float(k-1)*dl
        do j = 1, number/2
          x = xm+xr*points(j)
          if (abs(x) .ne. xmu0) then
            xi1ul = -(gg(j,:)/abs(x)*xl)
            xi1um = -(g0/xmu0*xl)
            xgama_0_ad(j,:) = xgama_0_ad(j,:)+xi1u_ad(k,j,1:nw)
     $*(2*i00*xmu0*(exp(
     $xi1um)-exp(xi1ul))/(gg(j,:)*xmu0-g0*abs(x)))
            xl_ad = xl_ad-xi1u_ad(k,j,1:nw)*2.*i00*
     $xgama_0(j,:)*xmu0*exp(xi1um)/(gg(j,:)*xmu0-g0*abs(x))*(g0/xmu0)
            xl_ad = xl_ad+xi1u_ad(k,j,1:nw)*2.*i00*
     $xgama_0(j,:)*xmu0*exp(xi1ul)
     $/(gg(j,:)*xmu0-g0*abs(x))*(gg(j,:)/abs(x))
            xi1u_ad(k,j,:) = 0.
            xil = -(gg(j,:)/abs(x)*xl)
            xim = -(g0/xmu0*xl)
            xgama_0_ad(j,:) = xgama_0_ad(j,:)
     $+xi_ad(k,j,:)*(2*i00*xmu0*(exp(
     $xim)-exp(xil))/(gg(j,:)*xmu0-g0*abs(x)))
            xl_ad = xl_ad-xi_ad(k,j,:)*2.*i00*xgama_0(j,:)
     $*xmu0*exp(xim)/(
     $gg(j,:)*xmu0-g0*abs(x))*(g0/xmu0)
            xl_ad = xl_ad+xi_ad(k,j,:)*2.*i00*xgama_0(j,:)
     $*xmu0*exp(xil)/(
     $gg(j,:)*xmu0-g0*abs(x))*(gg(j,:)/abs(x))
            xi_ad(k,j,:) = 0.
          else
            xi1uk = -(g0/xmu0*xl)
            xgama_0_ad(j,:) = xgama_0_ad(j,:)+xi1u_ad(k,j,1:nw)
     $*(2*i00*xl*exp(
     $xi1uk)/xmu0)
            xl_ad = xl_ad+xi1u_ad(k,j,1:nw)*(2.*i00*xgama_0(j,:)
     $*exp(xi1uk)/xmu0)
            xl_ad = xl_ad-xi1u_ad(k,j,1:nw)*2.*i00*xl*xgama_0(j,:)
     $*exp(xi1uk)/xmu0*(g0/xmu0)
            xi1u_ad(k,j,:) = 0.
            xik = -(g0/xmu0*xl)
            xgama_0_ad(j,:) = xgama_0_ad(j,:)+
     $xi_ad(k,j,:)*(2*i00*xl*exp(xik)/xmu0)
            xl_ad = xl_ad+xi_ad(k,j,:)*(2.*i00*xgama_0(j,:)
     $*exp(xik)/xmu0)
            xl_ad = xl_ad-xi_ad(k,j,:)*2.*i00*xl*xgama_0(j,:)
     $*exp(xik)/xmu0*(g0/xmu0)
            xi_ad(k,j,:) = 0.
          endif
        end do
        dl_ad = dl_ad+xl_ad*float(k-1)
        xl_ad = 0.
      end do
      do i = 1, number
        x = xm+xr*points(i)
        call fase_leafh_ad( xgama_0_ad(i,:),teta_01,acos(x) )
        xgama_0_ad(i,:) = 0.
      end do
      do k = 1, m
        sum_ad = 0.
        do i = number, 1, -1
          sum_ad = 0.
          sum_ad = sum_ad+q0m_ad(k,i,:)
          q0m_ad(k,i,:) = 0.
          do j = number, number/2+1, -1
            i0_ad(k+1,j,1:nw) = i0_ad(k+1,j,1:nw)+
     $sum_ad*(2*weights(j)*xr*
     $xgama_xy(i,j,:)/2.)
            i0_ad(k,j,1:nw) = i0_ad(k,j,1:nw)+
     $sum_ad*(2*weights(j)*xr*
     $xgama_xy(i,j,:)/2.)
            xgama_xy_ad(i,j,:) = xgama_xy_ad(i,j,:)+sum_ad*
     $(2*weights(j)*xr*(i0(k+1,j,1:nw)+i0(k,j,1:nw))/2.)
          end do
          sum_ad = 0.
        end do
      end do
      do i = 1, number
        y = xm+xr*points(i)
        do j = 1, number
          x = xm+xr*points(j)
          call fase_leafh_ad( xgama_xy_ad(i,j,:),acos(x),acos(y(1)) )
          xgama_xy_ad(i,j,:) = 0.
        end do
      end do
      do k = 1, m+1
        xl_ad = 0.
        xl = float(k-1)*dl
        do i = number/2+1, number
          x = xm+xr*points(i)
          i0h = -(gg(i,:)/x*(lai(1:nw)-xl))
          i0i = -(g0/xmu0*lai(1:nw))
          i0h_ad =2.*i0_ad(k,i,1:nw)*rs*i00*xmu0*exp(i0i)*exp(i0h)
          rs_ad(1:nw) =rs_ad(1:nw)+
     $2*i0_ad(k,i,1:nw)*i00*xmu0*exp(i0i)*exp(i0h)
          lai_ad(1:nw) =lai_ad(1:nw)-
     $2.*i0_ad(k,i,1:nw)*rs*i00*xmu0*g0/xmu0*exp(i0i)*
     $exp(i0h)
          lai_ad(1:nw) = lai_ad(1:nw)-i0h_ad*(gg(i,:)/x)
          xl_ad = xl_ad+i0h_ad*(gg(i,:)/x)
          i0_ad(k,i,:) = 0.
        end do
        dl_ad = dl_ad+xl_ad*float(k-1)
        xl_ad = 0.
      end do
      do k = m+1, 1, -1
        xl_ad = 0.
        xl = float(k-1)*dl
        do i = 1, number/2
          x = xm+xr*points(i)
          if (abs(x) .eq. xmu0) then
            xl_ad = xl_ad-i0_ad(k,i,1:nw)*
     $i00*(g0/xmu0)*exp(-(g0/xmu0*xl))
            i0_ad(k,i,:) = 0.
          else
            i0_ad(k,i,:) = 0.
          endif
        end do
        dl_ad = dl_ad+xl_ad*float(k-1)
        xl_ad = 0.
      end do
      do k = 1, m+1
        do j = 1, number
          xif_ad(k,j,:) = 0.
        end do
      end do
      lai_ad(1:nw) = lai_ad(1:nw)+dl_ad/float(m)
      dl_ad = 0.

      end subroutine multiple_dom_ad


      subroutine multiple_dommd(ipt, teta_01 )
c******************************************************************
c******************************************************************
c** this routine was generated by automatic differentiation.     **
c** fastopt: transformation of algorithm in fortran, taf 1.9.69  **
c******************************************************************
c******************************************************************
c==============================================
c referencing used modules
c==============================================
      use multiple_dom_store_ad

c==============================================
c all entries are defined explicitly
c==============================================
      use mo_nad
      implicit none

c==============================================
c declare arguments
c==============================================
      double precision :: teta_01
      integer ipt
c==============================================
c declare local variables
c==============================================
      double precision :: dl(nw)
      double precision :: g0(nw)
      double precision :: gg(40,nw)
      integer :: i
      double precision :: i00(nw)
      integer :: j
      integer :: k
      integer :: l
      integer :: m
      integer :: nl
      double precision :: q0m(21,40,nw)
      double precision :: q1(21,40,nw)
      double precision :: s(21,40,nw)
      double precision :: sum(nw)
      double precision :: x
      double precision :: xgama_0(40,nw)
      double precision :: xgama_xy(40,40,nw)
      double precision :: xi(21,40,nw)
      double precision :: xl(nw)
      double precision :: xm
      double precision :: xmu0
      double precision :: xr
      double precision :: y
c initialise locals
      dl=0
      g0=0
      gg=0
      i=0
      i00=0
      j=0
      k=0
      l=0
      m=0
      nl=0
      q0m=0
      q1=0
      s=0
      sum=0
      x=0
      xgama_0=0
      xgama_xy=0
      xi=0
      xl=0
      xm=0
      xmu0=0
      xr=0
      y=0
c**********************************************
c executable statements of routine
c**********************************************
      xmu0 = abs(cos(teta_01))
      m = 20
      dl = lai(1:nw)/float(m)
      call g_ross(g0,teta_01)
      xm = 0.5*(1.+(-1.))
      xr = 0.5*(1.-(-1.))
      i00 = 1.
      do j = 1, number
        x = xm+xr*points(j)
        call g_ross(gg(j,:),acos(x))
      end do
      do k = 1, m+1
        do j = 1, number
          s(k,j,:) = 0.
          xif(k,j,:) = 0.
        end do
      end do
      xi = 0.
      s = 0.
      do k = 1, m+1
        xl = float(k-1)*dl
        do i = 1, number/2
          x = xm+xr*points(i)
          if (abs(x) .eq. xmu0) then
            i0(k,i,1:nw) = i00*exp(-(g0/xmu0*xl))
          else
            i0(k,i,:) = 0.
          endif
        end do
      end do
      do k = m+1, 1, -1
        xl = float(k-1)*dl
        do i = number/2+1, number
          x = xm+xr*points(i)
          i0(k,i,1:nw) = 2.*rs*i00*xmu0*exp(-(g0/xmu0*lai(1:nw)))
     $*exp(-(gg(i,:)/x*(lai(1:nw)-xl)))
        end do
      end do
      do i = 1, number
        y = xm+xr*points(i)
        do j = 1, number
          x = xm+xr*points(j)
          call fase_leaf(xgama_xy(i,j,:),acos(x),acos(y))
        end do
      end do
      do k = m, 1, -1
        do i = 1, number
          sum = 0.
          do j = number/2+1, number
            sum = sum+weights(j)*xr*2.*xgama_xy(i,j,:)
     $*(i0(k+1,j,1:nw)+i0(k,j,1:nw))/2.
          end do
          q0m(k,i,:) = sum
        end do
      end do
      do i = 1, number
        x = xm+xr*points(i)
        call  fase_leaf(xgama_0(i,:),teta_01,acos(x))
      end do
      do k = 1, m+1
        xl = float(k-1)*dl
        do j = 1, number/2
          x = xm+xr*points(j)
          if (abs(x) .ne. xmu0) then
            xi(k,j,:) = i00*2.*xgama_0(j,:)*xmu0*
     $(exp(-(g0/xmu0*xl))-exp(-(
     $gg(j,:)/abs(x)*xl)))/(gg(j,:)*xmu0-g0*abs(x))
            xi1u(k,j,1:nw) = i00*2.*xgama_0(j,:)
     $*xmu0*(exp(-(g0/xmu0*xl))-exp(-
     $(gg(j,:)/abs(x)*xl)))/(gg(j,:)*xmu0-g0*abs(x))
          else
            xi(k,j,:) = i00*xl*2.*xgama_0(j,:)
     $*exp(-(g0/xmu0*xl))/xmu0
            xi1u(k,j,1:nw) = i00*xl*2.*xgama_0(j,:)
     $*exp(-(g0/xmu0*xl))/xmu0
          endif
        end do
      end do
      print*,'*1**',maxval(xi),minval(xi)
      print*,'*1a*',maxloc(xi),minloc(xi)


      xi1 = 0.
      do j = 1, number/2
        x = xm+xr*points(j)
        xi1(1:nw) = xi1(1:nw)+weights(j)*xr*abs(x)*2.*rs*xi(m+1,j,:)
      end do
      do k = m+1, 1, -1
        xl = float(k-1)*dl
        do j = number/2+1, number
          x = xm+xr*points(j)
	  if (j == 16) then
	   print*,'*C1',gg(j,:)
	   print*,'*C2',x
	   print*,'*C3',gg(j,:)/x
	   print*,'*C4',(lai(1:nw)-xl)
	   print*,'**4',-((gg(j,:)/x)*(lai(1:nw)-xl))
	   print*,'*C5',exp(-((gg(j,:)/x)*(lai(1:nw)-xl)))
	  endif
          xi(k,j,1:nw) = i00*2.*xgama_0(j,:)*
     $xmu0*(exp(-(g0/xmu0*xl))-exp(-(gg(
     $j,:)/x*(lai(1:nw)-xl)))*exp(-(g0/xmu0*lai(1:nw))))
     $/(g0*x+gg(j,:)*xmu0)
          xi1u(k,j,1:nw) = i00*2.*xgama_0(j,:)*
     $xmu0*(exp(-(g0/xmu0*xl))
     $-exp(-(gg(j,:)/x*(lai(1:nw)-xl)))*
     $exp(-(g0/xmu0*lai(1:nw))))/(g0*x+gg(j,:)
     $*xmu0)
        xi(k,j,1:nw) = amin1(1000.,amax1(-1000.,xi(k,j,1:nw)))
	xi1u(k,j,1:nw) = amin1(1000.,amax1(-1000.,xi1u(k,j,1:nw)))
	  print*,'***C5',j,k,xi(k,j,:),xi1u(k,j,:)
        end do
      end do
      print*,'*2**',minval(xi)
      print*,'*2a*',minloc(xi)

      do j = number/2+1, number
        xi(m+1,j,:) = 0.
        xi1u(m+1,j,:) = 0.
      end do
      do k = 1, m
        do i = 1, number
          sum = 0.
          do j = 1, number
            sum = sum+weights(j)*xr*2.*xgama_xy(i,j,:)
     $*(xi(k+1,j,:)+xi(k,j,:))/2.
          end do
          q1(k,i,:) = sum
        end do
      end do
      do k = 1, m+1
        do j = 1, number/2
          xi(k,j,:) = 0.
        end do
      end do
      nl = nlm
      do l = 1, nl
        multl_s_1h(:,:,l+nlm*(ipt-1),:) = s
        do k = 1, m
          multkl_xi_1h(:,k+21*(l-1)+21*nlm*(ipt-1),:) = xi(k,:,:)
          do j = 1, number/2
            x = xm+xr*points(j)
            xi(k+1,j,:) = (s(k,j,:)+q0m(k,j,:)+q1(k,j,:)-xi(k,j,:)
     $*(gg(j,:)/2.+x/dl))/(gg(j,:)/2.-x/dl)
	    xi(k+1,j,:) = amin1(1000.,amax1(-1000.,xi(k+1,j,:)))

          end do
        end do
        ximt = 0.
        multl_xi_2h(:,:,l+nlm*(ipt-1),:) = xi
        do j = 1, number/2
          x = xm+xr*points(j)
          ximt(1:nw) = ximt(1:nw)+weights(j)*xr*2.*rs*abs(x)*xi(m+1,j,:)
        end do
        do j = number/2+1, number
          xi(m+1,j,:) = ximt(1:nw)+xi1(1:nw)
          xi(m+1,j,:) = amin1(1000.,amax1(-1000.,xi(m+1,j,:)))

        end do
        multl_s_3h(:,:,l+nlm*(ipt-1),:) = s
        do k = m, 1, -1
          multkl_xi_2h(:,k+21*(l-1)+21*nlm*(ipt-1),:) = xi(k+1,:,:)
          do j = number/2+1, number
            x = xm+xr*points(j)
            xi(k,j,:) = (s(k,j,:)+q0m(k,j,:)+q1(k,j,:)-xi(k+1,j,:)
     $*(gg(j,:)/2.-x/dl))/(gg(j,:)/2.+x/dl)
	    xi(k,j,:) = amin1(1000.,amax1(-1000.,xi(k,j,:)))

          end do
        end do
        multl_xi_4h(:,:,l+nlm*(ipt-1),:) = xi
        do k = 1, m+1
          do j = 1, number
	    if (j == 1) then
	        print*,'****XI***',k,k,xi(k,j,:)
	    endif
            xif(k,j,1:nw) = xi(k,j,:)
          end do
        end do
        do k = 1, m
          do i = 1, number
            y = xm+xr*points(i)
            sum = 0.
            do j = 1, number
              x = xm+xr*points(j)
              sum = sum+weights(j)*xr*2.*xgama_xy(i,j,:)
     $*(xi(k+1,j,:)+xi(k,j,:))/2.
            end do
            s(k,i,:) = sum
          end do
        end do
      end do
      end subroutine multiple_dommd


      subroutine multiple_dom( teta_01 )
c******************************************************************
c******************************************************************
c** this routine was generated by automatic differentiation.     **
c** fastopt: transformation of algorithm in fortran, taf 1.9.69  **
c******************************************************************
c******************************************************************
c==============================================
c referencing used modules
c==============================================

c==============================================
c all entries are defined explicitly
c==============================================
      use mo_nad
      implicit none

c==============================================
c declare arguments
c==============================================
      double precision :: teta_01

c==============================================
c declare local variables
c==============================================
      double precision :: dl(nw)
      double precision :: g0(nw)
      double precision :: gg(40,nw)
      integer :: i
      double precision :: i00(nw)
      integer :: j
      integer :: k
      integer :: l
      integer :: m
      integer :: nl
      integer :: nt
      double precision :: q0m(21,40,nw)
      double precision :: q1(21,40,nw)
      double precision :: s(21,40,nw)
      double precision :: sum(nw)
      double precision :: x
      double precision :: xgama_0(40,nw)
      double precision :: xgama_xy(40,40,nw)
      double precision :: xi(21,40,nw)
      double precision :: xl(nw)
      double precision :: xm
      double precision :: xmu0
      double precision :: xnn(nw)
      double precision :: xr
      double precision :: y
c initialise locals
      dl=0
      g0=0
      gg=0
      i=0
      i00=0
      j=0
      k=0
      l=0
      m=0
      nl=0
      nt=0
      q0m=0
      q1=0
      s=0
      sum=0
      x=0
      xgama_0=0
      xgama_xy=0
      xi=0
      xl=0
      xm=0
      xmu0=0
      xnn=0
      xr=0
      y=0
c      print*,'n nwands',nw
      xmu0 = abs(cos(teta_01))
      m = 20
      dl = lai(1:nw)/float(m)
      call g_ross(g0,teta_01)
      xm = 0.5*(1.+(-1.))
      xr = 0.5*(1.-(-1.))
      i00 = 1.
      do j = 1, number
        x = xm+xr*points(j)
        call g_ross(gg(j,:),acos(x))
      end do
      do k = 1, m+1
        do j = 1, number
          s(k,j,:) = 0.
          xif(k,j,:) = 0.
        end do
      end do
      xi = 0.
      s = 0.
      do k = 1, m+1
        xl = float(k-1)*dl
        do i = 1, number/2
          x = xm+xr*points(i)
          if (abs(x) .eq. xmu0) then
            i0(k,i,1:nw) = i00*exp(-(g0/xmu0*xl))
          else
            i0(k,i,:) = 0.
          endif
        end do
      end do
      do k = m+1, 1, -1
        xl = float(k-1)*dl
        do i = number/2+1, number
          x = xm+xr*points(i)
          i0(k,i,1:nw) = 2.*rs*i00*xmu0*exp(-(g0/xmu0*lai(1:nw)))
     $*exp(-(gg(i,:)/x*(lai(1:nw)-xl)))
        end do
      end do
      do i = 1, number
        y = xm+xr*points(i)
        do j = 1, number
          x = xm+xr*points(j)
          call fase_leaf(xgama_xy(i,j,:),acos(x),acos(y))
        end do
      end do
      do k = m, 1, -1
        do i = 1, number
          y = xm+xr*points(i)
          sum = 0.
          do j = number/2+1, number
            x = xm+xr*points(j)
            sum = sum+weights(j)*xr*2.*xgama_xy(i,j,:)*(i0(k+1,j,1:nw)
     $+i0(k,j,1:nw))
     $/2.
          end do
          q0m(k,i,:) = sum
        end do
      end do
      do i = 1, number
        x = xm+xr*points(i)
        call fase_leaf(xgama_0(i,:),teta_01,acos(x))
      end do
      do k = 1, m+1
        xl = float(k-1)*dl
        do j = 1, number/2
          x = xm+xr*points(j)
          if (abs(x) .ne. xmu0) then
            xi(k,j,:) = i00*2.*xgama_0(j,:)*xmu0*(exp(-(g0/xmu0*xl))
     $-exp(-(gg(j,:)/abs(x)*xl)))/(gg(j,:)*xmu0-g0*abs(x))
            xi1u(k,j,1:nw) = i00*2.*xgama_0(j,:)*
     $xmu0*(exp(-(g0/xmu0*xl))
     $-exp(-(gg(j,:)/abs(x)*xl)))/(gg(j,:)*xmu0-g0*abs(x))
          else
            xi(k,j,:) = i00*xl*2.*xgama_0(j,:)*
     $exp(-(g0/xmu0*xl))/xmu0
            xi1u(k,j,1:nw) = i00*xl*2.*xgama_0(j,:)*
     $exp(-(g0/xmu0*xl))/xmu0
          endif
          xi(k,j,:) = amin1(1000.,amax1(-1000.,xi(k,j,:)))
          xi1u(k,j,:) = amin1(1000.,amax1(-1000.,xi1u(k,j,:)))

        end do
      end do
      xi1 = 0.
      do j = 1, number/2
        x = xm+xr*points(j)
        xi1(1:nw) = xi1(1:nw)+weights(j)*xr*abs(x)*2.*rs*xi(m+1,j,:)
      end do
      do k = m+1, 1, -1
        xl = float(k-1)*dl
        do j = number/2+1, number
          x = xm+xr*points(j)
          xi(k,j,:) = i00*2.*xgama_0(j,:)*xmu0*
     $(exp(-(g0/xmu0*xl))-exp(-(gg(j,:)/x*(lai(1:nw)-xl)))*
     $exp(-(g0/xmu0*lai(1:nw))))/(g0*x+gg(j,:)*xmu0)
          xi1u(k,j,1:nw) = i00*2.*xgama_0(j,:)*xmu0*
     $(exp(-(g0/xmu0*xl))-exp(-(gg(j,:)/x*(lai(1:nw)-xl)))*
     $exp(-(g0/xmu0*lai(1:nw))))/(g0*x+gg(j,:)*xmu0)
          xi(k,j,:) = amin1(1000.,amax1(-1000.,xi(k,j,:)))
          xi1u(k,j,:) = amin1(1000.,amax1(-1000.,xi1u(k,j,:)))

        end do
      end do
      do j = number/2+1, number
        xi(m+1,j,:) = 0.
        xi1u(m+1,j,:) = 0.
      end do
      do k = 1, m
        do i = 1, number
          y = xm+xr*points(i)
          sum = 0.
          do j = 1, number
            x = xm+xr*points(j)
            sum = sum+weights(j)*xr*2.*xgama_xy(i,j,:)*
     $(xi(k+1,j,:)+xi(k,j,:))
     $/2.
          end do
          q1(k,i,:) = sum
        end do
      end do
      do k = 1, m+1
        do j = 1, number/2
          xi(k,j,:) = 0.
        end do
      end do
      nl = nlm
      do l = 1, nl
        do k = 1, m
          do j = 1, number/2
            x = xm+xr*points(j)
            xi(k+1,j,:) = (s(k,j,:)+q0m(k,j,:)+q1(k,j,:)-xi(k,j,:)
     $*(gg(j,:)/2.+x/dl))/(gg(j,:)/2.-x/dl)
          xi(k+1,j,:) = amin1(1000.,amax1(-1000.,xi(k+1,j,:)))
          end do
        end do
        ximt = 0.
        do j = 1, number/2
          x = xm+xr*points(j)
          ximt(1:nw) = ximt(1:nw)+weights(j)*xr*2.*rs*abs(x)*xi(m+1,j,:)
        end do
        do j = number/2+1, number
          xi(m+1,j,:) = ximt(1:nw)+xi1(1:nw)
          xi(m+1,j,:) = amin1(1000.,amax1(-1000.,xi(m+1,j,:)))
        end do
        do k = m, 1, -1
          do j = number/2+1, number
            x = xm+xr*points(j)
            xi(k,j,:) = (s(k,j,:)+q0m(k,j,:)+q1(k,j,:)-xi(k+1,j,:)
     $*(gg(j,:)/2.-x/dl))/(gg(j,:)/2.+x/dl)
          xi(k,j,:) = amin1(1000.,amax1(-1000.,xi(k,j,:)))
          end do
        end do
        nt = 0
        do k = 1, m+1
          do j = 1, number
            xnn = abs(xif(k,j,1:nw)-xi(k,j,:))
c this part not clear
            if (xnn(1) .lt. 0.0001) then
              nt = nt+1
            endif
            xif(k,j,1:nw) = xi(k,j,:)
          end do
        end do
        do k = 1, m
          do i = 1, number
            y = xm+xr*points(i)
            sum = 0.
            do j = 1, number
              x = xm+xr*points(j)
              sum = sum+weights(j)*xr*2.*xgama_xy(i,j,:)
     $*(xi(k+1,j,:)+xi(k,j,:))/2.
            end do
            s(k,i,:) = sum
          end do
        end do
      end do
      end subroutine multiple_dom


      subroutine psi_leaf_m( vpsi_leaf_m,
     $teta_e, teta_i, teta_l )
c******************************************************************
c******************************************************************
c** this routine was generated by automatic differentiation.     **
c** fastopt: transformation of algorithm in fortran, taf 1.9.69  **
c******************************************************************
c******************************************************************
c==============================================
c all entries are defined explicitly
c==============================================
      use mo_nad
      implicit none

c==============================================
c declare arguments
c==============================================
      double precision :: vpsi_leaf_m(nw)
      double precision :: teta_e
      double precision :: teta_i
      double precision :: teta_l

c==============================================
c declare local variables
c==============================================
      double precision :: xh1(nw)
      double precision :: xh2(nw)
      double precision :: xh3(nw)
      double precision :: xh4(nw)
      double precision :: xmu_e
      double precision :: xmu_i
      double precision :: xmu_l
c initialise locals
      xh1=0
      xh2=0
      xh3=0
      xh4=0
c main code
      xmu_e = cos(teta_e)
      xmu_i = cos(teta_i)
      xmu_l = cos(teta_l)
      call xh_leaf(xh1,xmu_e,xmu_l)
      call xh_leaf(xh2,-xmu_i,xmu_l)
      call xh_leaf(xh3,-xmu_e,xmu_l)
      call xh_leaf(xh4,xmu_i,xmu_l)
      vpsi_leaf_m = xh1*xh2+xh3*xh4
      end subroutine psi_leaf_m


      subroutine psi_leaf_p(vpsi_leaf_p,
     $ teta_e, teta_i, teta_l )
c******************************************************************
c******************************************************************
c** this routine was generated by automatic differentiation.     **
c** fastopt: transformation of algorithm in fortran, taf 1.9.69  **
c******************************************************************
c******************************************************************
c==============================================
c all entries are defined explicitly
c==============================================
      use mo_nad
      implicit none

c==============================================
c declare arguments
c==============================================
      double precision :: vpsi_leaf_p(nw)
      double precision :: teta_e
      double precision :: teta_i
      double precision :: teta_l

c==============================================
c declare local variables
c==============================================
      double precision :: xh1(nw)
      double precision :: xh2(nw)
      double precision :: xh3(nw)
      double precision :: xh4(nw)
      double precision :: xmu_e
      double precision :: xmu_i
      double precision :: xmu_l
c initialise locals
      xh1=0
      xh2=0
      xh3=0
      xh4=0
c start code
      xmu_e = cos(teta_e)
      xmu_i = cos(teta_i)
      xmu_l = cos(teta_l)
      call xh_leaf(xh1,xmu_e,xmu_l)
      call xh_leaf(xh2,xmu_i,xmu_l)
      call xh_leaf(xh3,-xmu_e,xmu_l)
      call xh_leaf(xh4,-xmu_i,xmu_l)
      vpsi_leaf_p = xh1*xh2+xh3*xh4
      end subroutine psi_leaf_p


      subroutine psi_ross( vpsi_ross,teta_i, x )
c******************************************************************
c******************************************************************
c** this routine was generated by automatic differentiation.     **
c** fastopt: transformation of algorithm in fortran, taf 1.9.69  **
c******************************************************************
c******************************************************************
c==============================================
c all entries are defined explicitly
c==============================================
      use mo_nad
      implicit none

c==============================================
c declare arguments
c==============================================
      double precision :: vpsi_ross(nw)
      double precision :: teta_i
      double precision :: x

c==============================================
c declare local variables
c==============================================
      double precision :: fit
      double precision :: smu
      double precision :: xmu
      double precision :: xp
c initialise locals
      fit=0
      xp=0
c main code
      xmu = cos(x)
      smu = sin(x)
      if (xmu .eq. 1.) then
        vpsi_ross = cos(teta_i)
      else
        if (sin(teta_i) .eq. 0.) then
          vpsi_ross = xmu
        else
          if (smu .eq. 0.) then
            xp = 0.
          else
            xp = 1.*cos(teta_i)/sin(teta_i)*xmu/smu
          endif
          if (abs(xp) .gt. 1.) then
            vpsi_ross = cos(teta_i)*xmu
          else
            fit = acos(-xp)
            vpsi_ross = cos(teta_i)*xmu*(2.*fit/pi-1.)
     $+2./pi*sqrt(1.-cos(
     $teta_i)**2)*sqrt(1.-cos(x)**2)*sin(fit)
          endif
        endif
      endif
      vpsi_ross = abs(vpsi_ross)
      end subroutine psi_ross


      subroutine rho_0_nadh_ad( rho_0_nad_ad, teta_e, phi_e, x_lambda_i 
     $)
c******************************************************************
c******************************************************************
c** this routine was generated by automatic differentiation.     **
c** fastopt: transformation of algorithm in fortran, taf 1.9.69  **
c******************************************************************
c******************************************************************
c==============================================
c all entries are defined explicitly
c==============================================
      use mo_nad
      implicit none

c==============================================
c declare arguments
c==============================================
      double precision :: phi_e
      double precision, intent(inout) :: rho_0_nad_ad(nw)
      double precision :: teta_e
      double precision :: x_lambda_i(nw)

c==============================================
c declare local variables
c==============================================
      double precision :: help_h(nw)
      integer :: i
      integer :: i1
      double precision :: ke(nw)
      double precision :: ki(nw)
      integer :: n_c0
      double precision :: xg1(nw)
      double precision :: xg2(nw)
      double precision :: xh_p(nw)
      double precision :: xh_p_ad(nw)
      double precision :: xli(nw)
      double precision :: xli_ad(nw)
      double precision :: xs1(nw)
      double precision :: xs1_ad(nw)
      double precision :: xs2(nw)
      double precision :: xs2_ad(nw)
      double precision :: tmplai_ad(nw)
      double precision :: tmplai(nw)
c initialise locals
      help_h=0
      i=0
      i1=0
      ke=0
      ki=0
      n_c0=0
      xg1=0
      xg2=0
      xh_p=0
      xli=0
      xs1=0
      xs2=0
c----------------------------------------------
c reset local adjoint variables
c----------------------------------------------
      xh_p_ad = 0.
      xli_ad = 0.
      xs1_ad = 0.
      xs2_ad = 0.

c----------------------------------------------
c routine body
c----------------------------------------------
      n_c0 = lai(1)/x_lambda_i(1)
      call g_ross(xg1,teta_0)
      call  g_ross(xg2,teta_e)
      ki = xg1/abs(cos(teta_0))
      ke = xg2/cos(teta_e)
      xs1 = (1.-x_lambda_i*ki)**n_c0
      xs2 = 1.
      call geo(help_h,teta_e,teta_0,phi_e,phi_0)
      xli = c1(1:nw)/help_h
      tmplai = lai(1:nw)
      call hot_spot(xh_p,tmplai,xli)
      lai(1:nw) = tmplai
      do i = 1, n_c0
        xs2 = xs2*(1.-x_lambda_i*ke*xh_p)
      end do
      rs_ad(1:nw) = rs_ad(1:nw)+rho_0_nad_ad*xs2*xs1
      xs1_ad = xs1_ad+rho_0_nad_ad*rs*xs2
      xs2_ad = xs2_ad+rho_0_nad_ad*rs*xs1
      rho_0_nad_ad = 0.
      xs2 = 1.
      do i = n_c0, 1, -1
        xs2 = 1.
        do i1 = 1, i-1
          xs2 = xs2*(1.-x_lambda_i*ke*xh_p)
        end do
        xh_p_ad = xh_p_ad-xs2_ad*xs2*x_lambda_i*ke
        xs2_ad = xs2_ad*(1.-x_lambda_i*ke*xh_p)
      end do
      tmplai_ad = lai_ad(1:nw)
      tmplai = lai(1:nw)
      call hot_spoth_ad( xh_p_ad,tmplai,tmplai_ad,xli,xli_ad )
      lai_ad(1:nw) = tmplai_ad
      lai(1:nw) = tmplai
      xh_p_ad = 0.
      c1_ad(1:nw) = c1_ad(1:nw)+xli_ad/help_h
      xli_ad = 0.
      xs1_ad = 0.

      end subroutine rho_0_nadh_ad


      subroutine rho_0_nad( vrho_0_nad,
     $teta_e, phi_e, x_lambda_i )
c******************************************************************
c******************************************************************
c** this routine was generated by automatic differentiation.     **
c** fastopt: transformation of algorithm in fortran, taf 1.9.69  **
c******************************************************************
c******************************************************************
c==============================================
c all entries are defined explicitly
c==============================================
      use mo_nad
      implicit none

c==============================================
c declare arguments
c==============================================
      double precision :: phi_e
      double precision :: vrho_0_nad(nw)
      double precision :: teta_e
      double precision :: x_lambda_i(nw)

c==============================================
c declare local variables
c==============================================
      double precision :: help_h(nw)
      integer :: i
      double precision :: ke(nw)
      double precision :: ki(nw)
      integer :: n_c0
      double precision :: xg1(nw)
      double precision :: xg2(nw)
      double precision :: xh_p(nw)
      double precision :: xli(nw)
      double precision :: xs1(nw)
      double precision :: xs2(nw)
      double precision :: tmplai(nw)
c initialise locals
      help_h=0
      i=0
      ke=0
      ki=0
      n_c0=0
      xg1=0
      xg2=0
      xh_p=0
      xli=0
      xs1=0
      xs2=0
c main code
      n_c0 = lai(1)/x_lambda_i(1)
      call g_ross(xg1,teta_0)
      call g_ross(xg2,teta_e)
      ki = xg1/abs(cos(teta_0))
      ke = xg2/cos(teta_e)
      xs1 = (1.-x_lambda_i*ki)**n_c0
      xs2 = 1.
      call geo(help_h,teta_e,teta_0,phi_e,phi_0)
      xli = c1(1:nw)/help_h
      tmplai = lai(1:nw)
      call hot_spot(xh_p,tmplai,xli)
      lai(1:nw) = tmplai
      do i = 1, n_c0
        xs2 = xs2*(1.-x_lambda_i*ke*xh_p)
      end do
      vrho_0_nad = rs*xs2*xs1
      end  subroutine rho_0_nad


      subroutine rho_1_nadh_ad( rho_1_nad_ad, teta_e, phi_e, x_lambda_i 
     $)
c******************************************************************
c******************************************************************
c** this routine was generated by automatic differentiation.     **
c** fastopt: transformation of algorithm in fortran, taf 1.9.69  **
c******************************************************************
c******************************************************************
c==============================================
c all entries are defined explicitly
c==============================================
      use mo_nad
      implicit none

c==============================================
c declare arguments
c==============================================
      double precision :: phi_e
      double precision, intent(inout) :: rho_1_nad_ad(nw)
      double precision :: teta_e
      double precision :: x_lambda_i(nw)

c==============================================
c declare local variables
c==============================================
      double precision :: help_h(nw)
      integer :: k
      double precision :: ke(nw)
      double precision :: ki(nw)
      integer :: n_c0
      double precision :: rho_1_nadi(nw)
      double precision :: sum(nw)
      double precision :: sum_ad(nw)
      double precision :: x_hp(nw)
      double precision :: x_hp_ad(nw)
      double precision :: xc1(nw)
      double precision :: xg1(nw)
      double precision :: xg2(nw)
      double precision :: xga(nw)
      double precision :: xga_ad(nw)
      double precision :: xl(nw)
      double precision :: xlh_ad(nw)
      double precision :: xli(nw)
      double precision :: xli_ad(nw)

c initalise locals
      help_h=0
      k=0
      ke=0
      ki=0
      n_c0=0
      rho_1_nadi=0
      sum=0
      x_hp=0
      xc1=0
      xg1=0
      xg2=0
      xga=0
      xl=0
      xli=0
c----------------------------------------------
c reset local adjoint variables
c----------------------------------------------
      sum_ad = 0.
      x_hp_ad = 0.
      xga_ad = 0.
      xlh_ad = 0.
      xli_ad = 0.

c----------------------------------------------
c routine body
c----------------------------------------------
      n_c0 = lai(1)/x_lambda_i(1)
      call g_ross(xg1,teta_0)
      call g_ross(xg2,teta_e)
      ki = xg1/abs(cos(teta_0))
      ke = xg2/cos(teta_e)
      call gamma_leaf(xga,teta_0,phi_0,teta_e,phi_e)
      xc1 = 1.-x_lambda_i*ki
      call geo(help_h,teta_e,teta_0,phi_e,phi_0)
      xli = c1(1:nw)/help_h
      sum = 0.
      do k = 1, n_c0
        xl = x_lambda_i*k
        call hot_spot(x_hp,xl,xli)
        sum = sum+xc1**k*x_lambda_i*(1.-x_lambda_i*ke*x_hp)**k
      end do
      rho_1_nadi = cos(teta_0)
      sum_ad = sum_ad+rho_1_nad_ad/(cos(teta_e)*abs(rho_1_nadi))*xga
      xga_ad = xga_ad+rho_1_nad_ad*(sum/(cos(teta_e)*abs(rho_1_nadi)))
      rho_1_nad_ad = 0.
      do k = n_c0, 1, -1
        x_hp_ad = 0.
        xl = x_lambda_i*k
        call hot_spot(x_hp,xl,xli)
        x_hp_ad = x_hp_ad-sum_ad*xc1**k*x_lambda_i*x_lambda_i*ke*k*(1.-
     $x_lambda_i*ke*x_hp)**(k-1)
        call hot_spoth_ad( x_hp_ad,xl,xlh_ad,xli,xli_ad )
        x_hp_ad = 0.
      end do
      c1_ad(1:nw) = c1_ad(1:nw)+xli_ad/help_h
      xli_ad = 0.
      call gamma_leafh_ad( xga_ad,teta_0,phi_0,teta_e,phi_e )
      xga_ad = 0.

      end subroutine rho_1_nadh_ad


      subroutine rho_1_nad( vrho_1_nad, teta_e, phi_e, x_lambda_i )
c******************************************************************
c******************************************************************
c** this routine was generated by automatic differentiation.     **
c** fastopt: transformation of algorithm in fortran, taf 1.9.69  **
c******************************************************************
c******************************************************************
c==============================================
c all entries are defined explicitly
c==============================================
      use mo_nad
      implicit none

c==============================================
c declare arguments
c==============================================
      double precision :: phi_e
      double precision :: vrho_1_nad(nw)
      double precision :: teta_e
      double precision :: x_lambda_i(nw)

c==============================================
c declare local variables
c==============================================
      double precision :: help_h(nw)
      integer :: k
      double precision :: ke(nw)
      double precision :: ki(nw)
      integer :: n_c0
      double precision :: sum(nw)
      double precision :: x_hp(nw)
      double precision :: xc1(nw)
      double precision :: xg1(nw)
      double precision :: xg2(nw)
      double precision :: xga(nw)
      double precision :: xl(nw)
      double precision :: xli(nw)
c initialise locals
      help_h=0
      k=0
      ke=0
      ki=0
      n_c0=0
      sum=0
      x_hp=0
      xc1=0
      xg1=0
      xg2=0
      xga=0
      xl=0
      xli=0
c main code
      n_c0 = lai(1)/x_lambda_i(1)
      call g_ross(xg1,teta_0)
      call g_ross(xg2,teta_e)
      ki = xg1/abs(cos(teta_0))
      ke = xg2/cos(teta_e)
      call gamma_leaf(xga,teta_0,phi_0,teta_e,phi_e)
      xc1 = 1.-x_lambda_i*ki
      call geo(help_h,teta_e,teta_0,phi_e,phi_0)
      xli = c1(1:nw)/help_h
      sum = 0.
      do k = 1, n_c0
        xl = x_lambda_i*k
        call hot_spot(x_hp,xl,xli)
        sum = sum+xc1**k*x_lambda_i*(1.-x_lambda_i*ke*x_hp)**k
      end do
      vrho_1_nad = sum/(cos(teta_e)*abs(cos(teta_0)))*xga
      end  subroutine rho_1_nad


      subroutine rho_mult_nadh_ad( rho_mult_nad_ad, teta_u )
c******************************************************************
c******************************************************************
c** this routine was generated by automatic differentiation.     **
c** fastopt: transformation of algorithm in fortran, taf 1.9.69  **
c******************************************************************
c******************************************************************
c==============================================
c all entries are defined explicitly
c==============================================
      use mo_nad
      implicit none

c==============================================
c declare arguments
c==============================================
      double precision, intent(inout) :: rho_mult_nad_ad(nw)
      double precision :: teta_u

c==============================================
c declare local variables
c==============================================
      double precision :: aa(nw)
      double precision :: aa_ad(nw)
      double precision :: bb(nw)
      double precision :: bb_ad(nw)
      double precision :: dl(nw)
      double precision :: dl_ad(nw)
      double precision :: gu(nw)
      integer :: j
      integer :: k
      integer :: k1
      integer :: m
      double precision :: mu
      double precision :: s1(nw)
      double precision :: s1_ad(nw)
      double precision :: sum(nw)
      double precision :: sum1(nw)
      double precision :: sum1_ad(nw)
      double precision :: sum2(nw)
      double precision :: sum2_ad(nw)
      double precision :: sum_ad(nw)
      double precision :: x(nw)
      double precision :: xgama_u(40,nw)
      double precision :: xgama_u_ad(40,nw)
      double precision :: xim(21,nw)
      double precision :: xim_ad(21,nw)
      double precision :: xm(nw)
      double precision :: xq0u(21,nw)
      double precision :: xq0u_ad(21,nw)
      double precision :: xq1(21,nw)
      double precision :: xq1_ad(21,nw)
      double precision :: xr(nw)
      double precision :: xsu(21,nw)
      double precision :: xsu_ad(21,nw)
c initialise locals
      aa=0
      bb=0
      dl=0
      gu=0
      j=0
      k=0
      k1=0
      m=0
      mu=0
      s1=0
      sum=0
      sum1=0
      sum2=0
      x=0
      xgama_u=0
      xim=0
      xm=0
      xq0u=0
      xq1=0
      xr=0
      xsu=0
c----------------------------------------------
c reset local adjoint variables
c----------------------------------------------
      aa_ad = 0.
      bb_ad = 0.
      dl_ad = 0.
      s1_ad = 0.
      sum1_ad = 0.
      sum2_ad = 0.
      sum_ad = 0.
      xgama_u_ad = 0.
      xim_ad = 0.
      xq0u_ad = 0.
      xq1_ad = 0.
      xsu_ad = 0.
c      print*,'xx ..1',rho_mult_nad_ad, teta_u
c----------------------------------------------
c routine body
c----------------------------------------------
      m = 20
      dl = lai(1:nw)/m
      xm = 0.5*(1.-1.)
      xr = 0.5*(1.+1.)
      do j = 1, number
        x = xm+xr*points(j)
c        print*,'xx ..2',j,xgama_u(j,:),x(1),teta_u
        call fase_leaf(xgama_u(j,:),acos(x(1)),teta_u)
      end do
      do k = 1, m
        sum = 0.
        do j = 1, number
          sum = sum+2.*xgama_u(j,:)*xr*weights(j)*(xif(k+1,j,1:nw)
     $+xif(k,j,1:nw))/2.
        end do
        xsu(k,:) = sum
      end do
      do k = m, 1, -1
        sum1 = 0.
        do j = number/2+1, number
          sum1 = sum1+weights(j)*xr*2.*xgama_u(j,:)*
     $(i0(k+1,j,1:nw)+i0(k,j,1:nw))/2.
        end do
        xq0u(k,:) = sum1
      end do
      do k = 1, m
        sum2 = 0.
        do j = 1, number
          sum2 = sum2+2.*xgama_u(j,:)*xr*weights(j)*
     $(xi1u(k+1,j,1:nw)+xi1u(k,j,1:nw))/2.
        end do
        xq1(k,:) = sum2
      end do
      call  g_ross(gu,teta_u)
      mu = cos(teta_u)
      xim(m+1,:) = ximt(1:nw)+xi1(1:nw)
c      print*,'rho_mult_nad_ad',rho_mult_nad_ad
      xim_ad(1,:) = xim_ad(1,:)+rho_mult_nad_ad/(2.*abs(cos(teta_0)))
      rho_mult_nad_ad = 0.
      do k = 1, m
        xim(m+1,:) = ximt(1:nw)+xi1(1:nw)
        do k1 = m, k-(-1), -1
          s1 = xsu(k1,:)+xq1(k1,:)+xq0u(k1,:)
          aa = gu/2.-mu/dl
          bb = gu/2.+mu/dl
          xim(k1,:) = (s1-xim(k1+1,:)*aa)/bb
        end do
        s1 = xsu(k,:)+xq1(k,:)+xq0u(k,:)
        aa = gu/2.-mu/dl
        bb = gu/2.+mu/dl
        aa_ad = aa_ad-xim_ad(k,:)*(xim(k+1,:)/bb)
        bb_ad = bb_ad-xim_ad(k,:)*((s1-xim(k+1,:)*aa)/(bb*bb))
        s1_ad = s1_ad+xim_ad(k,:)/bb
c        print*,'xim_ad',xim_ad
        xim_ad(k+1,:) = xim_ad(k+1,:)-xim_ad(k,:)*(aa/bb)
        xim_ad(k,:) = 0.
        dl_ad = dl_ad-bb_ad*(mu/(dl*dl))
        bb_ad = 0.
        dl_ad = dl_ad+aa_ad*(mu/(dl*dl))
        aa_ad = 0.
        xq0u_ad(k,:) = xq0u_ad(k,:)+s1_ad
        xq1_ad(k,:) = xq1_ad(k,:)+s1_ad
        xsu_ad(k,:) = xsu_ad(k,:)+s1_ad
        s1_ad = 0.
      end do
      xi1_ad(1:nw) = xi1_ad(1:nw)+xim_ad(m+1,:)
      ximt_ad(1:nw) = ximt_ad(1:nw)+xim_ad(m+1,:)
      xim_ad(m+1,:) = 0.
      do k = m, 1, -1
        sum2_ad = 0.
        sum2_ad = sum2_ad+xq1_ad(k,:)
c        print*,'xq1_ad',xq1_ad
        xq1_ad(k,:) = 0.
        do j = number, 1, -1
          xgama_u_ad(j,:) = xgama_u_ad(j,:)+
     $sum2_ad*(2*xr*weights(j)
     $*(xi1u(k+1,j,1:nw)+xi1u(k,j,1:nw))/2.)
          xi1u_ad(k+1,j,1:nw) = 
     $xi1u_ad(k+1,j,1:nw)+sum2_ad*(2*xgama_u(j,:)
     $*xr*weights(j)/2.)
          xi1u_ad(k,j,1:nw) = 
     $xi1u_ad(k,j,1:nw)+sum2_ad*(2*xgama_u(j,:)
     $*xr*weights(j)/2.)
        end do
        sum2_ad = 0.
      end do
c      print*,xi1u_ad
      do k = 1, m
        sum1_ad = 0.
        sum1_ad = sum1_ad+xq0u_ad(k,:)
        xq0u_ad(k,:) = 0.
        do j = number, number/2+1, -1
          i0_ad(k+1,j,1:nw) = 
     $i0_ad(k+1,j,1:nw)+sum1_ad*(2*weights(j)*xr*
     $xgama_u(j,:)/2.)
          i0_ad(k,j,1:nw) = 
     $i0_ad(k,j,1:nw)+sum1_ad*(2*weights(j)*xr*
     $xgama_u(j,:)/2.)
          xgama_u_ad(j,:) = 
     $xgama_u_ad(j,:)+sum1_ad*(2*weights(j)*
     $xr*(i0(k+1,j,1:nw)+i0(k,j,1:nw))/2.)
        end do
        sum1_ad = 0.
      end do
      do k = m, 1, -1
        sum_ad = 0.
        sum_ad = sum_ad+xsu_ad(k,:)
        xsu_ad(k,:) = 0.
        do j = number, 1, -1
          xgama_u_ad(j,:) = 
     $xgama_u_ad(j,:)+sum_ad*(2*xr*weights(j)*
     $(xif(k+1,j,1:nw)+xif(k,j,1:nw))/2.)
          xif_ad(k+1,j,1:nw) = 
     $xif_ad(k+1,j,1:nw)+sum_ad*(2*xgama_u(j,:)*
     $xr*weights(j)/2.)
          xif_ad(k,j,1:nw) = 
     $xif_ad(k,j,1:nw)+sum_ad*(2*xgama_u(j,:)*
     $xr*weights(j)/2.)
        end do
        sum_ad = 0.
      end do
      do j = 1, number
        x = xm+xr*points(j)
        call fase_leafh_ad( xgama_u_ad(j,:),acos(x(1)),teta_u )
        xgama_u_ad(j,:) = 0.
      end do
      lai_ad(1:nw) = lai_ad(1:nw)+dl_ad/float(m)
      dl_ad = 0.

      end subroutine rho_mult_nadh_ad


      subroutine rho_mult_nad(vrho_mult_nad, teta_u )
c******************************************************************
c******************************************************************
c** this routine was generated by automatic differentiation.     **
c** fastopt: transformation of algorithm in fortran, taf 1.9.69  **
c******************************************************************
c******************************************************************
c==============================================
c all entries are defined explicitly
c==============================================
      use mo_nad
      implicit none

c==============================================
c declare arguments
c==============================================
      double precision :: vrho_mult_nad(nw)
      double precision :: teta_u

c==============================================
c declare local variables
c==============================================
      double precision :: aa(nw)
      double precision :: bb(nw)
      double precision :: dl(nw)
      double precision :: g0(nw)
      double precision :: gu(nw)
      integer :: i
      integer :: j
      integer :: k
      integer :: m
      double precision :: mu
      double precision :: s1(nw)
      double precision :: sum(nw)
      double precision :: sum1(nw)
      double precision :: sum2(nw)
      double precision :: x
      double precision :: xgama_u(40,nw)
      double precision :: xim(21,nw)
      double precision :: xm
      double precision :: xmu0
      double precision :: xq0u(21,nw)
      double precision :: xq1(21,nw)
      double precision :: xr
      double precision :: xsu(21,nw)
c initialise locals
      aa=0
      bb=0
      dl=0
      g0=0
      gu=0
      i=0
      j=0
      k=0
      m=0
      mu=0
      s1=0
      sum=0
      sum1=0
      sum2=0
      x=0
      xgama_u=0
      xim=0
      xm=0
      xmu0=0
      xq0u=0
      xq1=0
      xr=0
      xsu=0
c main code
      do i = 1, 21
        do j = 1, 20
        end do
      end do
      xmu0 = abs(cos(teta_0))
      m = 20
      dl = lai(1:nw)/m
      call g_ross(g0,teta_0)
      xm = 0.5*(1.-1.)
      xr = 0.5*(1.+1.)
      do j = 1, number
        x = xm+xr*points(j)
        call fase_leaf(xgama_u(j,:),acos(x),teta_u)
      end do
      print*,'m,nw',m,nw
      do k = 1, m
        sum = 0.
        do j = 1, number
c	  print*,'j,number,points(j),xm,xr',j,number,points(j),xm,xr
          x = xm+xr*points(j)
c	  print*,'xgama_u(j,:)',xgama_u(j,:)
c	  print*,'weights(j)',weights(j)
	  if (j == 1) then 
		print*,k
	  	print*,'xif(k+1,j,1:nw)',xif(k+1,j,1:nw)
    	  endif
c	  print*,'xif(k,j,1:nw)',xif(k,j,1:nw)
c	  print*,'sum',sum
          sum = sum+2.*xgama_u(j,:)*xr*weights(j)*(xif(k+1,j,1:nw)
     $+xif(k,j,1:nw))/2.
        end do
        xsu(k,:) = sum
      end do
c      print*,'xsu',xsu
      do k = m, 1, -1
        sum1 = 0.
        do j = number/2+1, number
          x = xm+xr*points(j)
          sum1 = sum1+weights(j)*xr*2.*xgama_u(j,:)*
     $(i0(k+1,j,1:nw)+i0(k,j,1:nw))/2.
        end do
        xq0u(k,:) = sum1
      end do
c      print*,'xq0u',xq0u
      do k = 1, m
        sum2 = 0.
        do j = 1, number
          x = xm+xr*points(j)
          sum2 = sum2+2.*xgama_u(j,:)*xr*weights(j)*(xi1u(k+1,j,1:nw)
     $+xi1u(k,j,1:nw))/2.
        end do
        xq1(k,:) = sum2
      end do
c      print*,'xq1',xq1
      call g_ross(gu,teta_u)
      mu = cos(teta_u)
      xim(m+1,:) = ximt(1:nw)+xi1(1:nw)
      do k = m, 1, -1
        s1 = xsu(k,:)+xq1(k,:)+xq0u(k,:)
        aa = gu/2.-mu/dl
        bb = gu/2.+mu/dl
        xim(k,:) = (s1-xim(k+1,:)*aa)/bb
      end do
c      print*,'xim',xim
      vrho_mult_nad = xim(1,:)/(2.*abs(cos(teta_0)))
c      print*,'vrho_mult_nad',vrho_mult_nad
c      print*,'xim(1,:)',xim(1,:)
c      print*,'teta_0',teta_0
c      print*,'(2.*abs(cos(teta_0)))',(2.*abs(cos(teta_0)))
      end  subroutine rho_mult_nad

      subroutine sun_fleckh_ad( sun_fleck_ad, teta_01 )
c******************************************************************
c******************************************************************
c** this routine was generated by automatic differentiation.     **
c** fastopt: transformation of algorithm in fortran, taf 1.9.69  **
c******************************************************************
c******************************************************************
c==============================================
c all entries are defined explicitly
c==============================================
      use mo_nad
      implicit none

c==============================================
c declare arguments
c==============================================
      double precision, intent(inout) :: sun_fleck_ad(nw)
      double precision :: teta_01

c==============================================
c declare local variables
c==============================================
      double precision :: a_trou(nw)
      double precision :: a_trou_ad(nw)
      double precision :: a_trouh(nw)
      double precision :: help_h(nw)
      double precision :: help_i(nw)
      double precision :: help_j(nw)
      double precision :: x_l_opt(nw)
      double precision :: x_lambda_trou(nw)
      double precision :: x_r1_ad(nw)
      double precision :: x_r2(nw)
      double precision :: x_trou(nw)
      double precision :: x_trou_ad(nw)
c initialise locals
      a_trou=0
      a_trouh=0
      help_h=0
      help_i=0
      help_j=0
      x_l_opt=0
      x_lambda_trou=0
      x_r2=0
      x_trou=0
c----------------------------------------------
c reset local adjoint variables
c----------------------------------------------
      a_trou_ad = 0.
      x_r1_ad = 0.
      x_trou_ad = 0.

c----------------------------------------------
c routine body
c----------------------------------------------
      x_l_opt = x_ly(1:nw)
      call g_ross(help_h,teta_01)
      x_r2 = abs(cos(teta_01))/(help_h*x_l_opt)
      call g_ross(help_i,teta_01)
      x_lambda_trou = -(log(0.9)*abs(cos(teta_01))/help_i)
      x_trou = x_lambda_trou/a_f(1:nw)
      call g_ross(help_j,teta_01)
      a_trou = (1.-x_trou*a_f(1:nw)*help_j/abs(cos(teta_01)))/x_trou
      x_r1_ad = x_r1_ad+sun_fleck_ad*sqrt(x_r2)
      sun_fleck_ad = 0.
      a_trou_ad = a_trou_ad+x_r1_ad*(1./(2.*sqrt(a_trou/pi))/pi)
      x_r1_ad = 0.
      a_trouh = cos(teta_01)
      a_f_ad(1:nw) = 
     $a_f_ad(1:nw)-a_trou_ad*(x_trou*help_j/abs(a_trouh)/x_trou)
      x_trou_ad = 
     $x_trou_ad-a_trou_ad*(a_f(1:nw)*help_j/abs(a_trouh)/x_trou+(
     $1.-x_trou*a_f(1:nw)*help_j/abs(a_trouh))/(x_trou*x_trou))
      a_trou_ad = 0.
      a_f_ad(1:nw) = 
     $a_f_ad(1:nw)-x_trou_ad*(x_lambda_trou/(a_f(1:nw)*a_f(1:nw)))
      x_trou_ad = 0.

      end subroutine sun_fleckh_ad


      subroutine sun_fleck( vsun_fleck,teta_01 )
c******************************************************************
c******************************************************************
c** this routine was generated by automatic differentiation.     **
c** fastopt: transformation of algorithm in fortran, taf 1.9.69  **
c******************************************************************
c******************************************************************
c==============================================
c all entries are defined explicitly
c==============================================
      use mo_nad
      implicit none

c==============================================
c declare arguments
c==============================================
      double precision :: vsun_fleck(nw)
      double precision :: teta_01

c==============================================
c declare local variables
c==============================================
      double precision :: a_trou(nw)
      double precision :: help_h(nw)
      double precision :: help_i(nw)
      double precision :: help_j(nw)
      double precision :: x_l_opt(nw)
      double precision :: x_lambda_trou(nw)
      double precision :: x_r1(nw)
      double precision :: x_r2(nw)
      double precision :: x_trou(nw)
c initialise locals
      a_trou=0
      help_h=0
      help_i=0
      help_j=0
      x_l_opt=0
      x_lambda_trou=0
      x_r1=0
      x_r2=0
      x_trou=0
c main code
      x_l_opt = x_ly(1:nw)
      call g_ross(help_h,teta_01)
      x_r2 = abs(cos(teta_01))/(help_h*x_l_opt)
      call g_ross(help_i,teta_01)
      x_lambda_trou = -(log(0.9)*abs(cos(teta_01))/help_i)
      x_trou = x_lambda_trou/a_f(1:nw)
      call g_ross(help_j,teta_01)
      a_trou = (1.-x_trou*a_f(1:nw)*help_j/abs(cos(teta_01)))/x_trou
      x_r1 = sqrt(a_trou/pi)
      vsun_fleck = sqrt(x_r2)*x_r1
      end  subroutine sun_fleck


      subroutine xh_leaf( vxh_leaf, xmu, xmu_l )
c******************************************************************
c******************************************************************
c** this routine was generated by automatic differentiation.     **
c** fastopt: transformation of algorithm in fortran, taf 1.9.69  **
c******************************************************************
c******************************************************************
c==============================================
c all entries are defined explicitly
c==============================================
      use mo_nad
      implicit none

c==============================================
c declare arguments
c==============================================
      double precision :: vxh_leaf(nw)
      double precision :: xmu
      double precision :: xmu_l

c==============================================
c declare local variables
c==============================================
      double precision :: x1
      double precision :: xfi(nw)
      double precision :: xh1(nw)
      double precision :: xh2(nw)
      double precision :: xh3(nw)
c initialise locals
      x1=0
      xfi=0
      xh1=0
      xh2=0
      xh3=0
c main code
      if (xmu .eq. 1.) then
        if (xmu_l .eq. 1.) then
          vxh_leaf = xmu*xmu_l
        else
          if (xmu_l .eq. (-1.)) then
            vxh_leaf = 0.
          else
            if (xmu_l .gt. 0.) then
              vxh_leaf = xmu*xmu_l
            else
              vxh_leaf = 0.
            endif
          endif
        endif
      else
        if (xmu_l .eq. 1.) then
          if (xmu .eq. 1.) then
            vxh_leaf = xmu*xmu_l
          else
            if (xmu .eq. (-1.)) then
              vxh_leaf = 0.
            else
              if (xmu .gt. 0.) then
                vxh_leaf = xmu*xmu_l
              else
                vxh_leaf = 0.
              endif
            endif
          endif
        else
          if (xmu .eq. (-1.)) then
            if (xmu_l .lt. 0.) then
              vxh_leaf = xmu*xmu_l
            else
              vxh_leaf = 0.
            endif
          else
            if (xmu_l .eq. (-1.)) then
              if (xmu .gt. 0.) then
                vxh_leaf = 0.
              else
                vxh_leaf = xmu*xmu_l
              endif
            else
              x1 = xmu*xmu_l/(sin(acos(xmu))*sin(acos(xmu_l)))
              if (x1 .gt. 1.) then
                vxh_leaf = xmu*xmu_l
              else
                if (x1 .lt. (-1.)) then
                  vxh_leaf = 0.
                else
                  xfi = acos(-x1)
                  xh1 = xmu*xmu_l*xfi
                  xh2 = sqrt(1.-xmu**2.)*sqrt(1.-xmu_l**2.)
                  xh3 = sin(xfi)
                  vxh_leaf = abs(xh1+xh2*xh3)/pi
                endif
              endif
            endif
          endif
        endif
      endif
      end  subroutine xh_leaf

subroutine msnadimbrf(nbands,nl,nv,lad,kab,kar,kw,km,n,s1,s2,s3,s4,theta_i,phi_i,theta_v,phi_v,xhc,xlai,rpl,brf,bandpass)
! multispectral version of nadimbrf
!      use dataspec_p5
      use  mo_nad
      implicit none
! passed terms
      integer :: lad,nv,nl
      integer :: nbands
      double precision :: kab,kar,kw,km,n,s1,s2,s3,s4
      double precision :: theta_v(nv),phi_v(nv),theta_i,phi_i !variable dimension
      double precision :: xlai,xhc,rpl
      double precision :: brf(nv,nbands) !changing to variable dimension
      double precision :: bandpass(nbands,nl)

! locals
      double precision :: xrl(nl),xtl(nl),xrs(nl)
      double precision :: wavelength(nl)
      double precision :: lrefl(nl)
      double precision :: ltrans(nl)
      double precision :: srefl(nl)
      integer :: j,thiswavelength
      integer :: k,l0,l1
      integer :: wavesamples(nl)
      double precision :: thisbandpass(nl)
      integer :: thisnbands
      double precision :: allbrf(nv,nl),somebrf(nl),result(nl),field(nl)
! initialise locals to 0
      wavesamples = 0
      xrl=0.
      xtl=0.
      xrs=0.
      wavelength=0.
      lrefl=0.
      ltrans=0.
      srefl=0.
      thiswavelength=0
      l0=0
      l1=0

! we have an int array of size [nl] called wavesamples
! this contains 1 if we need to simulate that wavelength and 0 otherwise
! The (normalised) bandpass functions are bandpass[nbands,nl]
! which are weightings 

! so first, sort out wavesamples as a mask
      do j=1,nbands
	thisbandpass(:) = bandpass(j,:)
        where(thisbandpass .gt. 0) wavesamples = 1
      enddo
      thisnbands = sum(wavesamples)
! when we come to call the rt model, we only need to process
! those wavebands where wavesamples == 1
! start the code
! The output, brf is of dimension [nv,nbands]
! but we have to use thisnbands
! for calculating the brf of dimensions allbrf[nv,thisnbands]

! the leaf & soil models work with all wavebands
      call leaf(wavelength,lrefl,ltrans, kab,kar,kw,km,n)
      call soil(wavelength,srefl,s1,s2,s3,s4)

! now pack up xrs, xrl,xtl
      xrs(1:thisnbands) = pack(srefl,wavesamples /= 0)
      xrl(1:thisnbands) = pack(lrefl,wavesamples /= 0)
      xtl(1:thisnbands) = pack(ltrans,wavesamples /= 0)

      nw = thisnbands
      call nadimbrf(theta_i,phi_i,nv,theta_v,phi_v,&
           lad,xrs(1:thisnbands),xhc,xlai,rpl,xrl(1:thisnbands),xtl(1:thisnbands),allbrf(:,1:thisnbands))
! now unpack for each waveband from allbrf(1,1:nw)
      somebrf(1:nw) = allbrf(1,1:nw)
      do j=1,nbands
        thisbandpass(:) = bandpass(j,:)
        field = 0.
        result = unpack(somebrf(1:nw),wavesamples /= 0,field)
	! now multiply element by element by thisbandpass
        ! and sum up
        brf(1,j) = sum(thisbandpass * result)
      end do
end

subroutine msnadimbrfmd(ipt,nbands,nl,nv,lad,kab,kar,kw,km,n,s1,s2,s3,s4,theta_i,phi_i,theta_v,phi_v,xhc,xlai,rpl,brf,bandpass)
! multispectral version of nadimbrf
!      use dataspec_p5
      use  mo_nad
      implicit none
! information passed
      integer :: lad,nv,ipt,nbands,nl
      double precision :: brf(nv,nbands) !changing to variable dimension
      double precision :: theta_v(nv),phi_v(nv),theta_i,phi_i !variable dimension
      double precision :: xlai,xhc,rpl
      double precision :: kab,kar,kw,km,n,s1,s2,s3,s4
      double precision :: bandpass(nbands,nl)
! local variables
      double precision :: lrefl(nl)
      double precision :: ltrans(nl)
      double precision :: srefl(nl)
      integer :: j,thiswavelength,k,l0,l1
      double precision :: wavelength(nl)
      double precision xrl(nl),xtl(nl),xrs(nl)
      double precision :: thisbandpass(nl)
      integer :: thisnbands,wavesamples(nl)
      double precision :: allbrf(nv,nl),somebrf(nl),result(nl),field(nl)

! initialise local variables
      wavesamples = 0
      lrefl=0.
      ltrans=0.
      srefl=0.
      thiswavelength=0
      l0=0
      l1=0
      wavelength=0.
      xrl=0.
      xtl=0.
      xrs=0.
! start the code
! we have an int array of size [nl] called wavesamples
! this contains 1 if we need to simulate that wavelength and 0 otherwise
! The (normalised) bandpass functions are bandpass[nbands,nl]
! which are weightings

! so first, sort out wavesamples as a mask
      do j=1,nbands
        thisbandpass(:) = bandpass(j,:)
        where(thisbandpass .gt. 0) wavesamples = 1
      enddo
      thisnbands = sum(wavesamples)
! when we come to call the rt model, we only need to process
! those wavebands where wavesamples == 1
! start the code
! The output, brf is of dimension [nv,nbands]
! but we have to use thisnbands
! for calculating the brf of dimensions allbrf[nv,thisnbands]

      call leaf(wavelength,lrefl,ltrans, kab,kar,kw,km,n)
      call soil(wavelength,srefl,s1,s2,s3,s4)

! now pack up xrs, xrl,xtl
      xrs(1:thisnbands) = pack(srefl,wavesamples /= 0)
      xrl(1:thisnbands) = pack(lrefl,wavesamples /= 0)
      xtl(1:thisnbands) = pack(ltrans,wavesamples /= 0)

      nw = thisnbands
      call nadimbrfmd(ipt,theta_i,phi_i,nv,theta_v,phi_v,lad,&
                      xrs(1:thisnbands),xhc,xlai,rpl,xrl(1:thisnbands),xtl(1:thisnbands),allbrf(:,1:thisnbands))
! now unpack for each waveband from allbrf(1,1:nw)
      somebrf(1:nw) = allbrf(1,1:nw)
      do j=1,nbands
        thisbandpass(:) = bandpass(j,:)
        field = 0.
        result = unpack(somebrf(1:nw),wavesamples /= 0,field)
        ! now multiply element by element by thisbandpass
        ! and sum up
        brf(1,j)  = sum(thisbandpass * result)
      end do
end

subroutine msnadimbrf_ad(ipt,nbands,nl,nv,lad,kab,kar,kw,km,n,s1,s2,s3,s4,&
theta_i,phi_i,theta_v,phi_v,xhc,xlai,rpl,thisbrf_ad&
,xlai_ad,xhc_ad,rpl_ad,xkab_ad,xkar_ad,xkw_ad,xkm_ad,xleafn_ad,xs1_ad,xs2_ad,xs3_ad,xs4_ad,bandpass)
      ! multispectral version of nadimbrf
!      use dataspec_p5
      use  mo_nad
      implicit none
! passed variables
      integer          :: lad,nv,ipt,nbands,nl
      double precision :: thisbrf_ad(nv,nbands)
      double precision :: theta_v(nv),phi_v(nv),theta_i,phi_i !variable dimension
      double precision :: xlai_ad,xhc_ad,rpl_ad
      double precision :: xkab_ad,xkar_ad,xkw_ad,xkm_ad,xleafn_ad
      double precision :: xs1_ad,xs2_ad,xs3_ad,xs4_ad
      double precision :: xlai,xhc,rpl
      double precision :: kab,kar,kw,km,n,s1,s2,s3,s4
      double precision :: bandpass(nbands,nl)

! local variables
      double precision :: lrl_ad(nl),ltl_ad(nl),lrs_ad(nl)
      double precision :: lhc_ad(nl),llai_ad(nl),lrpl_ad(nl)
      double precision :: xrl(nl),xtl(nl),xrs(nl),brfpack(nl)
      double precision :: lrefl(nl)
      double precision :: ltrans(nl)
      double precision :: srefl(nl)
      double precision :: drl_kab_ad(nbands),drl_kar_ad(nbands),drl_kw_ad(nbands),drl_km_ad(nbands),drl_n_ad(nbands)
      double precision :: dtl_kab_ad(nbands),dtl_kar_ad(nbands),dtl_kw_ad(nbands),dtl_km_ad(nbands),dtl_n_ad(nbands)
      double precision :: dsl_s1_ad(nbands),dsl_s2_ad(nbands),dsl_s3_ad(nbands),dsl_s4_ad(nbands)
      integer :: j,k,thiswavelength,l0,l1
      double precision :: wavelength(nl),nwave
      double precision :: drdkab(nl), drdkar(nl), drdkw(nl), drdm(nl)
      double precision :: dtdkab(nl), dtdkar(nl), dtdkw(nl), dtdm(nl),drdn(nl),dtdn(nl)
      double precision :: drefl_ds1(nl),drefl_ds2(nl),drefl_ds3(nl),drefl_ds4(nl)
      double precision :: brf_ad(nv,nbands) !changing to variable dimension
      double precision :: thisbandpass(nl),totalwavesamples(nbands)
      integer :: thisnbands,wavesamples(nl),sumwavesamples(nl)
      double precision :: this,allbrf_ad(nv,nl),somebrf(nl),result(nl),field(nl)
      double precision :: rsresult(nl),rlresult(nl),tlresult(nl),hcresult(nl),lairesult(nl),rplresult(nl)
      double precision :: s1result(nl),s2result(nl),s3result(nl),s4result(nl)
      double precision :: kabresult(nl),karresult(nl),kwresult(nl),kmresult(nl),knresult(nl)

! inittialise local variables
      allbrf_ad = 0
      wavesamples = 0
      sumwavesamples = 0
      drl_kab_ad=0.
      drl_kar_ad=0.
      drl_kw_ad=0.
      drl_km_ad=0.
      drl_n_ad=0.
      dtl_kab_ad=0.
      dtl_kar_ad=0.
      dtl_kw_ad=0.
      dtl_km_ad=0.
      dtl_n_ad=0.
      dsl_s1_ad=0.
      dsl_s2_ad=0.
      dsl_s3_ad=0.
      dsl_s4_ad=0.
      thiswavelength=0
      l0=0
      l1=0
!      wavelength=0
!      drdkab=0
!      drdkar=0
!      drdkw=0
!      drdm=0
!      dtdkab=0
!      dtdkar=0
!      dtdkw=0
!      dtdm=0
!      drdn=0
!      dtdn=0
!      drefl_ds1=0
!      drefl_ds2=0
!      drefl_ds3=0
!      drefl_ds4=0
      brf_ad=0
      lrl_ad=0.
      ltl_ad=0.
      lrs_ad=0.
      lhc_ad=0.
      llai_ad=0.
      lrpl_ad=0.
      xrl=0.
      xtl=0.
      xrs=0.
      lrefl=0.
      ltrans=0.
      srefl=0.
! start the code 
! we have an int array of size [nl] called wavesamples
! this contains 1 if we need to simulate that wavelength and 0 otherwise
! The (normalised) bandpass functions are bandpass[nbands,nl]
! which are weightings

! so first, sort out wavesamples as a mask
      do j=1,nbands
        thisbandpass(:) = bandpass(j,:)
        where(thisbandpass .gt. 0) 
		where (wavesamples .ne. 1) sumwavesamples = 1
		wavesamples = 1
	end where
! NB allbrf_ad is *input* below , so we have to load it up with a weighted version of thisbrf_ad(nv,nbands)
        allbrf_ad(1,:) = allbrf_ad(1,:) + thisbrf_ad(1,j)  *  thisbandpass
        totalwavesamples(j) = sum(sumwavesamples)
	sumwavesamples=0
      enddo
      thisnbands = sum(wavesamples)
! when we come to call the rt model, we only need to process
! those wavebands where wavesamples == 1
! We achieve this using wavesamples as a mask
! start the code
! The output, brf is of dimension [nv,nbands]
! but we have to use thisnbands
! for calculating the brf of dimensions allbrf_ad[nv,thisnbands]

      call leaf(wavelength,lrefl,ltrans, kab,kar,kw,km,n)
      call soil(wavelength,srefl,s1,s2,s3,s4)
      call leaf_ad(wavelength,drdkab,drdkar,drdkw,drdm,dtdkab,dtdkar,dtdkw,dtdm,drdn,dtdn,kab,kar,kw,km,n)
      call soil_ad(wavelength,drefl_ds1,drefl_ds2,drefl_ds3,drefl_ds4,s1,s2,s3,s4)
! now pack up xrs, xrl,xtl & allbrf_ad
      xrs(1:thisnbands) = pack(srefl,wavesamples /= 0)
      xrl(1:thisnbands) = pack(lrefl,wavesamples /= 0)
      xtl(1:thisnbands) = pack(ltrans,wavesamples /= 0)
      brfpack(1:thisnbands) = pack(allbrf_ad(1,:),wavesamples /= 0)
!	print*,brfpack(1:thisnbands)
!      allbrf_ad(1,1:thisnbands) = brfpack(1:thisnbands)
      nw = thisnbands
! NB allbrf_ad is *input* here, so we have to load it up with a weighted version of thisbrf_ad(nv,nbands)
      call nadimbrf_ad(ipt,theta_i,phi_i,nv,theta_v,phi_v,lad,xrs(1:nw),&
             lrs_ad(1:nw),xhc,lhc_ad(1:nw),&
             xlai,llai_ad(1:nw),rpl,lrpl_ad(1:nw),xrl(1:nw),lrl_ad(1:nw),xtl(1:nw),ltl_ad(1:nw),brfpack(1:nw))
!  now do the partials
! what we get out is e.g. lrs_ad : dr/drs
! what we want, is a bandpass-weighted 
! e.g. xs1_ad : dr/ds1 = sum ( bandpass(l) * dr(l)/drs * drs(l)/ds1 )
! where sum(bandpass(l)) = 1
      field=0
      rsresult = unpack(lrs_ad(1:nw),wavesamples /= 0,field)
      field = 0.
      rlresult = unpack(lrl_ad(1:nw),wavesamples /= 0,field)
      field = 0.
      tlresult = unpack(ltl_ad(1:nw),wavesamples /= 0,field)
      field = 0.
      hcresult = unpack(lhc_ad(1:nw),wavesamples /= 0,field)
      field = 0.
      lairesult = unpack(llai_ad(1:nw),wavesamples /= 0,field)
      field = 0.
      rplresult = unpack(lrpl_ad(1:nw),wavesamples /= 0,field)
      s1result = rsresult * drefl_ds1
      s2result = rsresult * drefl_ds2
      s3result = rsresult * drefl_ds3
      s4result = rsresult * drefl_ds4
      kabresult = drdkab*rlresult + dtdkab*tlresult
      karresult = drdkar*rlresult + dtdkar*tlresult
      kwresult  = drdkw*rlresult + dtdkw*tlresult
      kmresult  = drdm*rlresult + dtdm*tlresult
      knresult  = drdn*rlresult + drdn*tlresult
      do j=1,nbands
        thisbandpass(:) = bandpass(j,:)
	xs1_ad = xs1_ad + sum(s1result * thisbandpass)*totalwavesamples(j)
        xs2_ad = xs2_ad + sum(s2result * thisbandpass)*totalwavesamples(j)
        xs3_ad = xs3_ad + sum(s3result * thisbandpass)*totalwavesamples(j)
        xs4_ad = xs4_ad + sum(s4result * thisbandpass)*totalwavesamples(j)
	xkab_ad = xkab_ad + sum(kabresult*thisbandpass)*totalwavesamples(j)
        xkar_ad = xkar_ad + sum(karresult*thisbandpass)*totalwavesamples(j)
        xkw_ad = xkw_ad + sum(kwresult*thisbandpass)*totalwavesamples(j)
        xkm_ad = xkm_ad + sum(kmresult*thisbandpass)*totalwavesamples(j)
        xleafn_ad = xleafn_ad + sum(knresult*thisbandpass)*totalwavesamples(j)
	xhc_ad = xhc_ad + sum(thisbandpass * hcresult)*totalwavesamples(j)
        xlai_ad= xlai_ad + sum(thisbandpass * lairesult)*totalwavesamples(j)
        rpl_ad = rpl_ad + sum(thisbandpass * rplresult)*totalwavesamples(j)
      enddo
! zero the adjoint of brf
      thisbrf_ad(1,:) = 0.
end

c                           disclaimer
c
c   this file was generated by taf version 1.9.69
c
c   fastopt disclaims  all  warranties,  eprior_xess  or  implied,
c   including (without limitation) all implied  warranties  of
c   merchantability  or fitness for a particular purpose, with
c   respect to the software and user programs.   in  no  event
c   shall  fastopt be liable for any lost or anticipated prof-
c   its, or any indirect, incidental, exemplary,  special,  or
c   consequential  damages, whether or not fastopt was advised
c   of the possibility of such damages.
c
c                           haftungsbeschraenkung
c   fastopt gibt ausdruecklich keine gewaehr, explizit oder indirekt,
c   bezueglich der brauchbarkeit  der software  fuer einen bestimmten
c   zweck.   unter  keinen  umstaenden   ist  fastopt   haftbar  fuer
c   irgendeinen verlust oder nicht eintretenden erwarteten gewinn und
c   allen indirekten,  zufaelligen,  exemplarischen  oder  speziellen
c   schaeden  oder  folgeschaeden  unabhaengig  von einer eventuellen
c   mitteilung darueber an fastopt.
c
      subroutine nadimbrf_ad( ipt,theta_i, phi_i, nv, 
     $theta_v, phi_v,
     $ lad, xrs, xrs_ad, xhc, xhc_ad, xlai, xlai_ad, rpl, rpl_ad, xrl,
     $ xrl_ad, xtl, xtl_ad, brf_ad) 
c******************************************************************
c******************************************************************
c** this routine was generated by automatic differentiation.     **
c** fastopt: transformation of algorithm in fortran, taf 1.9.69  **
c******************************************************************
c******************************************************************
c==============================================
c all entries are defined explicitly
c==============================================
      use  mo_nad
      use dataSpec_p5
      implicit none

c==============================================
c declare arguments
c==============================================
      integer :: nv,ipt
      double precision :: brf_ad(nv,nw)
      integer :: lad
      double precision :: phi_i
      double precision :: phi_v(nv)
      double precision :: rpl
      double precision :: rpl_ad(nw)
      double precision :: theta_i
      double precision :: theta_v(nv)
      double precision :: xhc
      double precision :: xhc_ad(nw)
      double precision :: xlai
      double precision :: xlai_ad(nw)
      double precision :: xrl(nw)
      double precision :: xrl_ad(nw)
      double precision :: xrs(nw)
      double precision :: xrs_ad(nw)
      double precision :: xtl(nw)
      double precision :: xtl_ad(nw)

c==============================================
c declare local variables
c==============================================
      double precision :: help_h
      double precision :: help_i(nw)
      double precision :: help_j(nw)
      integer :: i
      integer :: na
      double precision :: phi(nv)
      double precision :: r1_ad(nw)
      double precision :: r2_ad(nw)
      double precision :: r3_ad(nw)
      double precision :: teta(nv)
      double precision :: x_lambda_i(nw)
      double precision :: xmeas_ad(nw)
      double precision :: tmplai_ad(nw)
      double precision :: tmplai(nw)
c      print*, 'xx1',ipt,theta_i, phi_i, nv,nw
c      print*,'xx2',theta_v, phi_v
c      print*, 'xx3',lad, xrs, xrs_ad, xhc, xhc_ad, xlai, xlai_ad 
c      print*,'xx4',rpl, rpl_ad, xrl
c      print*, 'xx5',xrl_ad, xtl, xtl_ad, brf_ad
c      brf_ad=1
c initialise local variables
      help_h = 0
      help_i = 0
      help_j = 0
      na = 0
      phi = 0
      teta=0
      x_lambda_i=0
      tmplai_ad=0
c----------------------------------------------
c reset local adjoint variables
c----------------------------------------------
      r1_ad = 0.
      r2_ad = 0.
      r3_ad = 0.
      xmeas_ad = 0.
c----------------------------------------------
c routine body
c----------------------------------------------
      lai(1:nw) = xlai
      h_c(1:nw) = xhc
      df(1:nw) = rpl*2.
      ild = lad
      rl(1:nw) = xrl
      tl(1:nw) = xtl
      rs(1:nw) = xrs
      na = nv
      teta_0 = (180.-theta_i)*pi/180.
      phi_0 = phi_i*pi/180.
      do i = 1, na
        teta(i) = theta_v(i)*pi/180.
        phi(i) = phi_v(i)*pi/180.
      end do
      number = 16
      help_h = -1.
      call gauleg( help_h,1.,points,weights,number )
      call bunnik( ild )
      tmplai = lai(1:nw)
      call archi( tmplai,teta_0 )
      lai(1:nw) = tmplai
      call multiple_dom(teta_0 )
      do i = na, 1, -1

        call g_ross(help_i,teta_0)
        call g_ross(help_j,teta(i))
        x_lambda_i = 0.01*abs(cos(teta_0))/help_i*abs(cos(teta(i)))/
     $help_j

        if(lai(1)/x_lambda_i(1) > 100) then
          x_lambda_i(1) = lai(1)/100
        endif
        xmeas_ad = xmeas_ad+brf_ad(i,1:nw)
        brf_ad(i,:) = 0.

        r1_ad = r1_ad+xmeas_ad
        r2_ad = r2_ad+xmeas_ad
        r3_ad = r3_ad+xmeas_ad
        xmeas_ad = 0.

        call rho_mult_nadh_ad( r3_ad,teta(i) )
        r3_ad = 0.

        call rho_1_nadh_ad( r2_ad,teta(i),phi(i),x_lambda_i )
        r2_ad = 0.
        call rho_0_nadh_ad( r1_ad,teta(i),phi(i),x_lambda_i )
        r1_ad = 0.
      end do
      call multiple_dom_ad( ipt,teta_0 )
      tmplai_ad = lai_ad(1:nw)
      tmplai = lai(1:nw)
      call archi_ad( tmplai,tmplai_ad,teta_0 )
      lai_ad(1:nw) = tmplai_ad
      lai(1:nw) = tmplai
      xrs_ad(1:nw) = xrs_ad(1:nw)+rs_ad(1:nw)
      rs_ad = 0.
      xtl_ad(1:nw) = xtl_ad(1:nw)+tl_ad(1:nw)
      tl_ad = 0.
      xrl_ad(1:nw) = xrl_ad(1:nw)+rl_ad(1:nw)
      rl_ad = 0.
      rpl_ad(1:nw) = rpl_ad(1:nw)+2*df_ad(1:nw)
      df_ad = 0.
      xhc_ad(1:nw) = xhc_ad(1:nw)+h_c_ad(1:nw)
      h_c_ad = 0.
      xlai_ad(1:nw) = xlai_ad(1:nw)+tmplai_ad
c      print*,'xxhere',xlai_ad,lai_ad
      lai_ad =  0.
      end subroutine nadimbrf_ad


      subroutine nadimbrfmd( ipt,theta_i, phi_i, 
     $nv, theta_v, phi_v, lad, 
     $xrs, xhc, xlai, rpl, xrl, xtl, brf )
c******************************************************************
c******************************************************************
c** this routine was generated by automatic differentiation.     **
c** fastopt: transformation of algorithm in fortran, taf 1.9.69  **
c******************************************************************
c******************************************************************
c==============================================
c all entries are defined explicitly
c==============================================
      use mo_nad
      implicit none
      integer ipt
c==============================================
c declare arguments
c==============================================
      integer :: nv
      double precision :: brf(nv,nw)
      integer :: lad
      double precision :: phi_i
      double precision :: phi_v(nv)
      double precision :: rpl
      double precision :: theta_i
      double precision :: theta_v(nv)
      double precision :: xhc
      double precision :: xlai
      double precision :: xrl(nw)
      double precision :: xrs(nw)
      double precision :: xtl(nw)

c==============================================
c declare local variables
c==============================================
      double precision :: help_h
      double precision :: help_i(nw)
      double precision :: help_j(nw)
      integer :: i
      integer :: na
      double precision :: phi(nv)
      double precision :: r1(nw)
      double precision :: r2(nw)
      double precision :: r3(nw)
      double precision :: teta(nv)
      double precision :: x_lambda_i(nw)
      double precision :: xmeas
      double precision :: tmplai(nw)
c initialise locals
      help_h=0
      help_i=0
      help_j=0
      na=0
      phi=0
      r1=0
      r2=0
      r3=0
      teta=0
      x_lambda_i=0
      xmeas=0
c**********************************************
c executable statements of routine
c**********************************************
      lai(1:nw) = xlai
      h_c(1:nw) = xhc
      df(1:nw) = rpl*2.
      ild = lad
      rl(1:nw) = xrl
      tl(1:nw) = xtl
      rs(1:nw) = xrs
      na = nv
      teta_0 = (180.-theta_i)*pi/180.
      phi_0 = phi_i*pi/180.
      do i = 1, na
        teta(i) = theta_v(i)*pi/180.
        phi(i) = phi_v(i)*pi/180.
      end do
      number = 16
      help_h = -1.
      call gauleg( help_h,1.,points,weights,number )
      call bunnik( ild )
      tmplai = lai(1:nw)
      call archi( tmplai,teta_0 )
      lai(1:nw) = tmplai
      call multiple_dommd(ipt, teta_0 )
      do i = 1, na
        call g_ross(help_i,teta_0)
        call  g_ross(help_j,teta(i))
        x_lambda_i = 0.01*abs(cos(teta_0))/help_i*abs(cos(teta(i)))/
     $help_j
        call rho_0_nad(r1,teta(i),phi(i),x_lambda_i)
        call rho_1_nad(r2,teta(i),phi(i),x_lambda_i)
        call rho_mult_nad(r3,teta(i))
        print*,'r1',r1
        print*,'r2',r2
        print*,'r3',r3

        brf(i,:)= r3+r1+r2
      end do
      end subroutine nadimbrfmd


      subroutine nadimbrf( theta_i, phi_i, nv, theta_v, 
     $ phi_v, lad, xrs,
     $ xhc, xlai, rpl, xrl, xtl, brf )
c******************************************************************
c******************************************************************
c** this routine was generated by automatic differentiation.     **
c** fastopt: transformation of algorithm in fortran, taf 1.9.69  **
c******************************************************************
c******************************************************************
c==============================================
c all entries are defined explicitly
c==============================================
      use mo_nad
      use dataspec_p5
      implicit none
c==============================================
c declare arguments
c==============================================
      integer :: nv
      double precision :: brf(nv,nw)
      integer :: lad
      double precision :: phi_i
      double precision :: phi_v(nv)
      double precision :: rpl
      double precision :: theta_i
      double precision :: theta_v(nv)
      double precision :: xhc
      double precision :: xlai
      double precision :: xrl(nw)
      double precision :: xrs(nw)
      double precision :: xtl(nw)

c==============================================
c declare local variables
c==============================================
      double precision :: help_h
      double precision :: help_i(nw)
      double precision :: help_j(nw)
      integer :: i
      integer :: na
      double precision :: phi(nv)
      double precision :: r1(nw)
      double precision :: r2(nw)
      double precision :: r3(nw)
      double precision :: teta(nv)
      double precision :: x_lambda_i(nw)
      double precision :: tmplai(nw)
c      double precision :: xmeas
c initialise locals
      help_h=0
      help_i=0
      help_j=0
      na=0
      phi=0
      r1=0
      r2=0
      r3=0
      teta=0
      x_lambda_i=0
c start code
      lai(1:nw) = xlai
      h_c(1:nw) = xhc
      df(1:nw) = rpl*2.
      ild = lad
      rl(1:nw) = xrl
      tl(1:nw) = xtl
      rs(1:nw) = xrs
      na = nv
      teta_0 = (180.-theta_i)*pi/180.
      phi_0 = phi_i*pi/180.
      do i = 1, na
        teta(i) = theta_v(i)*pi/180.
        phi(i) = phi_v(i)*pi/180.
      end do
      number = 16
      help_h = -1.
      call gauleg( help_h,1.,points,weights,number )
      call bunnik( ild )
      tmplai = lai(1:nw)
      call archi( tmplai,teta_0 )
      lai(1:nw) = tmplai
      call multiple_dom( teta_0 )
      do i = 1, na
        call g_ross(help_i,teta_0)
        call g_ross(help_j,teta(i))
        x_lambda_i = 0.01*abs(cos(teta_0))/help_i*abs(cos(teta(i)))/
     $help_j
        call rho_0_nad(r1,teta(i),phi(i),x_lambda_i)
        call rho_1_nad(r2,teta(i),phi(i),x_lambda_i)
        call rho_mult_nad(r3,teta(i))
        brf(1,1:nw)= r3+r1+r2
      end do
      end subroutine nadimbrf

subroutine printleaf_ad(wavelength,drdkab,drdkar,drdkw,drdm,dtdkab,dtdkar,dtdkw,dtdm,drdn,dtdn)
      use dataspec_p5
      double precision   :: dr1(nl),dt1(nl),drn(nl),dtn(nl),wavelength(nl)
      double precision   :: drdkab(nl), drdkar(nl), drdkw(nl), drdm(nl)
      double precision   :: dtdkab(nl), dtdkar(nl), dtdkw(nl), dtdm(nl),drdn(nl),dtdn(nl)
      do i=1,nl
        print*,wavelength(i),drdkab(i), drdkar(i), drdkw(i), drdm(i),drdn(i),dtdkab(i), dtdkar(i), dtdkw(i), dtdm(i),dtdn(i)
      enddo

end

subroutine printleaf(wavelength,refl, trans)
      use dataspec_p5
      double precision   :: kk(nlmax),k(nl)
      double precision   :: wavelength(nl)
      double precision   :: refl(nl)
      double precision   :: trans(nl)

      common /kleaf/ kk

      k = kk(1:nl)
      do i=1,nl
        print*,wavelength(i),refl(i),trans(i),k(i)
      enddo
end

subroutine leaf(wavelength,refl, trans, kab,kar,kw,km,n)
      use dataspec_p5
      double precision   :: wavelength(nl)
      double precision   :: refl(nl)
      double precision   :: trans(nl)
      double precision   :: kk(nlmax),k1(nl),k2(nl),k3(nl)
      double precision   :: transmission(nl)
      double precision   :: rek(nlmax),rik(nlmax)
      double precision   :: re(nl),ri(nl),k(nl)
      double precision   :: tn(nl),w(nl),delta(nl)
      double precision   :: ptheta(nl)
      double precision   :: kab,kar,kw,km,n
      common /leaf_params/ rek,rik
      common /kleaf/ kk

	k = kk(1:nl)
	re = rek(1:nl)
	ri = rik(1:nl)
! this is an approximation to the transmission, theta
      ptheta = 0.354824 + 0.0315842*(nrefrac-1.35)
      wavelength = lambda
      k1 = 1.194494
      k2 =  -0.0343164638713112* (nrefrac-1.35)
      k3 =  - .0110496402235069*((nrefrac-1.35)**2)
      k = (acab*kab + acar*kar + acw*kw + acm*km)*(k1+k2+k3)
      transmission = (1 - ptheta)*exp(-k)/(1 - ptheta*exp(-k))
! end of this approximation
      tn = (n*ri)*(transmission**(2))
      w = (1 - ri) * transmission / (1 - ri * transmission)
      delta = (tn) / (transmission**n + tn)
      refl = re + (1 - re) *w * delta
      trans = (1 - re) *w *(1 - delta )  
end

subroutine leaf_ad_anc(kab,kar,kw,km,n)
      use dataspec_p5
      double precision   :: rek(nlmax),rik(nlmax),kk(nlmax),e1(nl),n1(nl),e2(nl),e3(nl),e4(nl),e5(nl),e6(nl),e7(nl)
      double precision   :: mult(nl),k1(nl),k2(nl),k3(nl),dr1k(nlmax),dt1k(nlmax),drnk(nlmax),dtnk(nlmax)
      double precision   :: kab,kar,kw,km,n
      double precision   :: ptheta(nl),p2(nl),p3(nl),re(nl),ri(nl),k(nl)
      common /leaf_params/ rek,rik
      common /leaf_advars/ dr1k,dt1k,drnk,dtnk

	re = rek(1:nl)
	ri = rik(1:nl)
	k = kk(1:nl)

      ptheta = 0.354824 + 0.0315842*(nrefrac-1.35)
      k1 = 1.194494
      k2 =  -0.0343164638713112* (nrefrac-1.35)
      k3 =  - .0110496402235069*((nrefrac-1.35)**2)
      mult = (k1+k2+k3)
      k = (acab*kab + acar*kar + acw*kw + acm*km)*(k1+k2+k3)
      e1 = exp(k)
      p2 = (1-ptheta)*(1-ptheta)
      p3 = -p2*(1-ptheta)
      n1 = ((-1+ptheta)/(ptheta-e1))**n
      e2 = (e1 + ptheta*(-1 + ri) - ri)**2
      e3 = (e1 - ptheta)**2
      e4 = (e3*n1+n*p2*ri)**2
      e5 = (e1 - ptheta)**3
      e6 = (1 + (n*p2*ri)/ (e3* n1))**2
      e7 = log((-1 + ptheta)/ (-e1 + ptheta))
      dr1k(1:nl) = mult * (e1*n*p3*(re-1)*(ri-1)*ri*(n*p2*ri-(e1-ptheta)*n1*(e1*(n-3)-(n-3)*ptheta+(n-2)*(ptheta-1)*ri)))/(e2*e4)
      dt1k(1:nl) = mult * (e1*(ptheta-1)*(re-1)*(ri-1)*(1+(n*p2*ri*(e1*(n-1)+ptheta-n*ptheta+(n-2)*(ptheta-1)*ri))/(e5*n1)))/(e2*e6)
      drnk(1:nl) =   (e3* p3*n1* (-1 + re)*(-1 + ri)*ri*(-1 + n*e7))/((e1 + ptheta*(-1 + ri) - ri)* e4)
      dtnk(1:nl) =  - ((e3* p3*n1* (-1 + re)*(-1 + ri)*ri*(-1 + n*e7))/ ((e1 + ptheta*(-1 + ri) - ri)*e4))
end

subroutine leaf_ad(wavelength,drdkab,drdkar,drdkw,drdm,dtdkab,dtdkar,dtdkw,dtdm,drdn,dtdn,kab,kar,kw,km,n)
      use dataspec_p5
      implicit none
      double precision   :: dr1(nlmax),dt1(nl),drn(nl),dtn(nl),wavelength(nl)
      double precision   :: drdkab(nl), drdkar(nl), drdkw(nl), drdm(nl)
      double precision   :: dtdkab(nl), dtdkar(nl), dtdkw(nl), dtdm(nl),drdn(nl),dtdn(nl)
      double precision   :: kab,kar,kw,km,n
      double precision   :: refl(nl),trans(nl),refl1(nl),trans1(nl)
      double precision   :: dr1k(nlmax),dt1k(nlmax),drnk(nlmax),dtnk(nlmax)
      common /leaf_advars/ dr1k,dt1k,drnk,dtnk

      wavelength = lambda
      call leaf_ad_anc(kab,kar,kw,km,n)
      drdkab = acab * dr1k(1:nl)
      drdkar = acar * dr1k(1:nl)
      drdkw = acw * dr1k(1:nl)
      drdm = acm * dr1k(1:nl)
      dtdkab  = acab * dt1k(1:nl)
      dtdkar = acar * dt1k(1:nl)
      dtdkw = acw * dt1k(1:nl)
      dtdm = acm * dt1k(1:nl)
      drdn = drnk(1:nl)
      dtdn = dtnk(1:nl)
end


subroutine leafprep(nbands_to_use,bands_to_use)
      use dataspec_p5
      implicit none

      integer nbands_to_use
      integer bands_to_use(nbands_to_use)

      double precision   :: rek(nlmax),rik(nlmax)
      double precision   :: t1(nbands_to_use),t2(nbands_to_use)
      double precision    :: ang1
      double precision    :: ang2
      common /leaf_params/ rek,rik

      nl = nbands_to_use
      call subsetspectra(nbands_to_use,bands_to_use)
      ang1=90.0
      ang2=40.0
      call tav_abs(t2,ang2,nrefrac)
      call tav_abs(t1,ang1,nrefrac)
      rek(1:nl) = 1.0 - t2
      rik(1:nl) = 1.0 - t1/(nrefrac*nrefrac)
       
end

!     ******************************************************************
!     tav(teta0,ref0) computation of the transmittivity at the leaf 
!     surface for a given incidence solid angle. teta0 is the incidence
!     solid angle (in radian). the average angle that works in most 
!     cases is 59deg*pi/180. ref0 is the refaction index.
!
!     jacquemoud s., 1992
! 
!     ******************************************************************
!     stern f., 1964, transmission of isotropic radiation across an
!     interface between two dielectrics, appl.opt., vol.3, 1:111-113
!     allen w.a., 1973, transmission of isotropic light across a
!     dielectric surface in two and three dimensions, j.opt.soc.am.,
!     vol.63, 6:664-666
!	  feret et al. (2008), prospect-4 and 5: advances in the leaf optical
!	  properties model separating photosynthetic pigments, remote sensing of
!	  environment
!     ******************************************************************

subroutine tav_abs(op,teta0,ref0)
      use spectrum_width_p5
      double precision teta,ref,teta0,ref0(nl),op(nl)
      double precision ref2,tav_ab
      double precision a,b,b1,b2,k,pi
      double precision ts,tp,tp1,tp2,tp3,tp4,tp5
      integer count
pi	=	3.1415926

do count=1,nl
teta=   teta0

ref	=	ref0(count)

if (teta.eq.0.) then
	tav_ab=4.*ref/(ref+1.)**2
else

ref2=	ref**2
a	=	(ref+1.)**2/2.
k	=	-(ref2-1.)**2/4.
teta=	pi*teta/180.


if (teta.eq.pi/2.) then
	b1=0.
else
	b1=dsqrt((sin(teta)*sin(teta)-(ref2+1.)/2.)**2+k)
endif

b2	=	sin(teta)*sin(teta)-(ref2+1.)/2.
b	=	b1-b2
ts	=	(k**2/(6.*b**3)+k/b-b/2.)-(k**2/(6.*a**3)+k/a-a/2.)
tp1	=	-2.*ref2*(b-a)/(ref2+1.)**2
tp2	=	-2.*ref2*(ref2+1.)*dlog(b/a)/(ref2-1.)**2
tp3	=	ref2*(1./b-1./a)/2.
tp4	=	16.*ref2**2*(ref2**2+1.)*dlog((2.*(ref2+1.)*b-(ref2-1.)**2)/ &
(2.*(ref2+1.)*a-(ref2-1.)**2))/((ref2+1.)**3*(ref2-1.)**2)
tp5	=	16.*ref2**3*(1./(2.*(ref2+1.)*b-(ref2-1.)**2)-1./(2.*(ref2&
+1.)*a-(ref2-1.)**2))/(ref2+1.)**3
tp	=	tp1+tp2+tp3+tp4+tp5
tav_ab	=	(ts+tp)/(2.*sin(teta)*sin(teta))
endif
op(count) = tav_ab
enddo
return
end

subroutine soil(wavelength,srefl,s1,s2,s3,s4)
      use dataspec_p5
      implicit none
      integer :: notok(nl)
      double precision   :: wavelength(nl)
      double precision   :: srefl(nl),s1,s2,s3,s4

      srefl=s1*phis1+s2*phis2+s3*phis3+s4*phis4
end

subroutine soil_ad(wavelength,drefl_ds1,drefl_ds2,drefl_ds3,drefl_ds4,s1,s2,s3,s4)
      use dataspec_p5
      implicit none
      double precision   :: wavelength(nl)
      double precision   :: srefl(nl),s1,s2,s3,s4
      double precision   :: drefl_ds1(nl),drefl_ds2(nl),drefl_ds3(nl),drefl_ds4(nl)

      drefl_ds1 = phis1
      drefl_ds2 = phis2
      drefl_ds3 = phis3
      drefl_ds4 = phis4

end

!     -*- f90 -*-
!     This file is autogenerated with f2py (version:1)
!     It contains Fortran 90 wrappers to fortran functions.

      
      subroutine f2pyinitmo_rtmodel(f2pysetupfunc)
      use mo_rtmodel, only : skab
      use mo_rtmodel, only : lad
      use mo_rtmodel, only : rtmodel_nparam
      use mo_rtmodel, only : rtmodel_param_names
      use mo_rtmodel, only : xkar
      use mo_rtmodel, only : xleafn_ad
      use mo_rtmodel, only : xleafn
      use mo_rtmodel, only : skar
      use mo_rtmodel, only : slai
      use mo_rtmodel, only : rpl
      use mo_rtmodel, only : xkab
      use mo_rtmodel, only : xs2
      use mo_rtmodel, only : xs3
      use mo_rtmodel, only : skw
      use mo_rtmodel, only : xs1
      use mo_rtmodel, only : xs4
      use mo_rtmodel, only : xkm
      use mo_rtmodel, only : xs2_ad
      use mo_rtmodel, only : rtmodel_spectralinterval
      use mo_rtmodel, only : nwmax
      use mo_rtmodel, only : xs4_ad
      use mo_rtmodel, only : xs1_ad
      use mo_rtmodel, only : skm
      use mo_rtmodel, only : xlai_ad
      use mo_rtmodel, only : xkw
      use mo_rtmodel, only : xkar_ad
      use mo_rtmodel, only : rtmodel_version
      use mo_rtmodel, only : xkw_ad
      use mo_rtmodel, only : xkm_ad
      use mo_rtmodel, only : rtmodel_subversion
      use mo_rtmodel, only : rtmodel_spectralmax
      use mo_rtmodel, only : rtmodel_spectralmin
      use mo_rtmodel, only : xhc
      use mo_rtmodel, only : rpl_ad
      use mo_rtmodel, only : xlai
      use mo_rtmodel, only : xhc_ad
      use mo_rtmodel, only : rtmodel_param_minmax
      use mo_rtmodel, only : xs3_ad
      use mo_rtmodel, only : xkab_ad
      external f2pysetupfunc
      call f2pysetupfunc(skab,lad,rtmodel_nparam,rtmodel_param_names,xka&
     &r,xleafn_ad,xleafn,skar,slai,rpl,xkab,xs2,xs3,skw,xs1,xs4,xkm,xs2_&
     &ad,rtmodel_spectralinterval,nwmax,xs4_ad,xs1_ad,skm,xlai_ad,xkw,xk&
     &ar_ad,rtmodel_version,xkw_ad,xkm_ad,rtmodel_subversion,rtmodel_spe&
     &ctralmax,rtmodel_spectralmin,xhc,rpl_ad,xlai,xhc_ad,rtmodel_param_&
     &minmax,xs3_ad,xkab_ad)
      end subroutine f2pyinitmo_rtmodel

      
      subroutine f2pyinitspectrum_width_p5(f2pysetupfunc)
      use spectrum_width_p5, only : nlmax
      use spectrum_width_p5, only : nl
      external f2pysetupfunc
      call f2pysetupfunc(nlmax,nl)
      end subroutine f2pyinitspectrum_width_p5

      subroutine f2py_dataspec_p5_getdims_acar(r,s,f2pysetdata,flag)
      use dataspec_p5, only: d => acar

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_dataspec_p5_getdims_acar
      subroutine f2py_dataspec_p5_getdims_acab(r,s,f2pysetdata,flag)
      use dataspec_p5, only: d => acab

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_dataspec_p5_getdims_acab
      subroutine f2py_dataspec_p5_getdims_phis4(r,s,f2pysetdata,flag)
      use dataspec_p5, only: d => phis4

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_dataspec_p5_getdims_phis4
      subroutine f2py_dataspec_p5_getdims_phis1(r,s,f2pysetdata,flag)
      use dataspec_p5, only: d => phis1

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_dataspec_p5_getdims_phis1
      subroutine f2py_dataspec_p5_getdims_phis3(r,s,f2pysetdata,flag)
      use dataspec_p5, only: d => phis3

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_dataspec_p5_getdims_phis3
      subroutine f2py_dataspec_p5_getdims_phis2(r,s,f2pysetdata,flag)
      use dataspec_p5, only: d => phis2

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_dataspec_p5_getdims_phis2
      subroutine f2py_dataspec_p5_getdims_nrefrac(r,s,f2pysetdata,flag)
      use dataspec_p5, only: d => nrefrac

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_dataspec_p5_getdims_nrefrac
      subroutine f2py_dataspec_p5_getdims_acm(r,s,f2pysetdata,flag)
      use dataspec_p5, only: d => acm

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_dataspec_p5_getdims_acm
      subroutine f2py_dataspec_p5_getdims_acw(r,s,f2pysetdata,flag)
      use dataspec_p5, only: d => acw

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_dataspec_p5_getdims_acw
      subroutine f2py_dataspec_p5_getdims_lambda(r,s,f2pysetdata,flag)
      use dataspec_p5, only: d => lambda

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_dataspec_p5_getdims_lambda
      
      subroutine f2pyinitdataspec_p5(f2pysetupfunc)
      use dataspec_p5, only : acabfull
      use dataspec_p5, only : nrefracfull
      use dataspec_p5, only : acmfull
      use dataspec_p5, only : phis3full
      use dataspec_p5, only : acwfull
      use dataspec_p5, only : acar
      use dataspec_p5, only : acab
      use dataspec_p5, only : phis4
      use dataspec_p5, only : phis4full
      use dataspec_p5, only : phis1full
      use dataspec_p5, only : phis1
      use dataspec_p5, only : phis3
      use dataspec_p5, only : phis2
      use dataspec_p5, only : lambdafull
      use dataspec_p5, only : nrefrac
      use dataspec_p5, only : acm
      use dataspec_p5, only : acarfull
      use dataspec_p5, only : acw
      use dataspec_p5, only : itmp
      use dataspec_p5, only : phis2full
      use dataspec_p5, only : lambda
      external f2pysetupfunc
      external f2py_dataspec_p5_getdims_acar
      external f2py_dataspec_p5_getdims_acab
      external f2py_dataspec_p5_getdims_phis4
      external f2py_dataspec_p5_getdims_phis1
      external f2py_dataspec_p5_getdims_phis3
      external f2py_dataspec_p5_getdims_phis2
      external f2py_dataspec_p5_getdims_nrefrac
      external f2py_dataspec_p5_getdims_acm
      external f2py_dataspec_p5_getdims_acw
      external f2py_dataspec_p5_getdims_lambda
      call f2pysetupfunc(acabfull,nrefracfull,acmfull,phis3full,acwfull,&
     &f2py_dataspec_p5_getdims_acar,f2py_dataspec_p5_getdims_acab,f2py_d&
     &ataspec_p5_getdims_phis4,phis4full,phis1full,f2py_dataspec_p5_getd&
     &ims_phis1,f2py_dataspec_p5_getdims_phis3,f2py_dataspec_p5_getdims_&
     &phis2,lambdafull,f2py_dataspec_p5_getdims_nrefrac,f2py_dataspec_p5&
     &_getdims_acm,acarfull,f2py_dataspec_p5_getdims_acw,itmp,phis2full,&
     &f2py_dataspec_p5_getdims_lambda)
      end subroutine f2pyinitdataspec_p5

      subroutine f2py_multiple_dom_store_ad_getdims_multl_s_3h(r,s,f2pys&
     &etdata,flag)
      use multiple_dom_store_ad, only: d => multl_s_3h

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1),s(2),s(3),s(4)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_multiple_dom_store_ad_getdims_multl_s_3h
      subroutine f2py_multiple_dom_store_ad_getdims_multl_xi_4h(r,s,f2py&
     &setdata,flag)
      use multiple_dom_store_ad, only: d => multl_xi_4h

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1),s(2),s(3),s(4)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_multiple_dom_store_ad_getdims_multl_xi_4h
      subroutine f2py_multiple_dom_store_ad_getdims_multkl_xi_1h(r,s,f2p&
     &ysetdata,flag)
      use multiple_dom_store_ad, only: d => multkl_xi_1h

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1),s(2),s(3)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_multiple_dom_store_ad_getdims_multkl_xi_1h
      subroutine f2py_multiple_dom_store_ad_getdims_multl_s_1h(r,s,f2pys&
     &etdata,flag)
      use multiple_dom_store_ad, only: d => multl_s_1h

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1),s(2),s(3),s(4)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_multiple_dom_store_ad_getdims_multl_s_1h
      subroutine f2py_multiple_dom_store_ad_getdims_multkl_xi_2h(r,s,f2p&
     &ysetdata,flag)
      use multiple_dom_store_ad, only: d => multkl_xi_2h

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1),s(2),s(3)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_multiple_dom_store_ad_getdims_multkl_xi_2h
      subroutine f2py_multiple_dom_store_ad_getdims_multl_xi_2h(r,s,f2py&
     &setdata,flag)
      use multiple_dom_store_ad, only: d => multl_xi_2h

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1),s(2),s(3),s(4)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_multiple_dom_store_ad_getdims_multl_xi_2h
      
      subroutine f2pyinitmultiple_dom_store_ad(f2pysetupfunc)
      use multiple_dom_store_ad, only : multkl_multiple_dom
      use multiple_dom_store_ad, only : multl_s_3h
      use multiple_dom_store_ad, only : multl_xi_4h
      use multiple_dom_store_ad, only : multkl_xi_1h
      use multiple_dom_store_ad, only : multl_multiple_dom
      use multiple_dom_store_ad, only : multl_s_1h
      use multiple_dom_store_ad, only : multkl_xi_2h
      use multiple_dom_store_ad, only : multl_xi_2h
      external f2pysetupfunc
      external f2py_multiple_dom_store_ad_getdims_multl_s_3h
      external f2py_multiple_dom_store_ad_getdims_multl_xi_4h
      external f2py_multiple_dom_store_ad_getdims_multkl_xi_1h
      external f2py_multiple_dom_store_ad_getdims_multl_s_1h
      external f2py_multiple_dom_store_ad_getdims_multkl_xi_2h
      external f2py_multiple_dom_store_ad_getdims_multl_xi_2h
      call f2pysetupfunc(multkl_multiple_dom,f2py_multiple_dom_store_ad_&
     &getdims_multl_s_3h,f2py_multiple_dom_store_ad_getdims_multl_xi_4h,&
     &f2py_multiple_dom_store_ad_getdims_multkl_xi_1h,multl_multiple_dom&
     &,f2py_multiple_dom_store_ad_getdims_multl_s_1h,f2py_multiple_dom_s&
     &tore_ad_getdims_multkl_xi_2h,f2py_multiple_dom_store_ad_getdims_mu&
     &ltl_xi_2h)
      end subroutine f2pyinitmultiple_dom_store_ad

      subroutine f2py_mo_nad_getdims_h_c_ad(r,s,f2pysetdata,flag)
      use mo_nad, only: d => h_c_ad

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_mo_nad_getdims_h_c_ad
      subroutine f2py_mo_nad_getdims_x_nf(r,s,f2pysetdata,flag)
      use mo_nad, only: d => x_nf

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_mo_nad_getdims_x_nf
      subroutine f2py_mo_nad_getdims_tl_ad(r,s,f2pysetdata,flag)
      use mo_nad, only: d => tl_ad

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_mo_nad_getdims_tl_ad
      subroutine f2py_mo_nad_getdims_df_ad(r,s,f2pysetdata,flag)
      use mo_nad, only: d => df_ad

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_mo_nad_getdims_df_ad
      subroutine f2py_mo_nad_getdims_ximt_ad(r,s,f2pysetdata,flag)
      use mo_nad, only: d => ximt_ad

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_mo_nad_getdims_ximt_ad
      subroutine f2py_mo_nad_getdims_h_c(r,s,f2pysetdata,flag)
      use mo_nad, only: d => h_c

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_mo_nad_getdims_h_c
      subroutine f2py_mo_nad_getdims_xif(r,s,f2pysetdata,flag)
      use mo_nad, only: d => xif

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1),s(2),s(3)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_mo_nad_getdims_xif
      subroutine f2py_mo_nad_getdims_xi1u(r,s,f2pysetdata,flag)
      use mo_nad, only: d => xi1u

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1),s(2),s(3)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_mo_nad_getdims_xi1u
      subroutine f2py_mo_nad_getdims_xi1u_ad(r,s,f2pysetdata,flag)
      use mo_nad, only: d => xi1u_ad

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1),s(2),s(3)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_mo_nad_getdims_xi1u_ad
      subroutine f2py_mo_nad_getdims_rs_ad(r,s,f2pysetdata,flag)
      use mo_nad, only: d => rs_ad

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_mo_nad_getdims_rs_ad
      subroutine f2py_mo_nad_getdims_xif_ad(r,s,f2pysetdata,flag)
      use mo_nad, only: d => xif_ad

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1),s(2),s(3)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_mo_nad_getdims_xif_ad
      subroutine f2py_mo_nad_getdims_tl(r,s,f2pysetdata,flag)
      use mo_nad, only: d => tl

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_mo_nad_getdims_tl
      subroutine f2py_mo_nad_getdims_rl_ad(r,s,f2pysetdata,flag)
      use mo_nad, only: d => rl_ad

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_mo_nad_getdims_rl_ad
      subroutine f2py_mo_nad_getdims_rl(r,s,f2pysetdata,flag)
      use mo_nad, only: d => rl

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_mo_nad_getdims_rl
      subroutine f2py_mo_nad_getdims_i0(r,s,f2pysetdata,flag)
      use mo_nad, only: d => i0

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1),s(2),s(3)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_mo_nad_getdims_i0
      subroutine f2py_mo_nad_getdims_lai(r,s,f2pysetdata,flag)
      use mo_nad, only: d => lai

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_mo_nad_getdims_lai
      subroutine f2py_mo_nad_getdims_df(r,s,f2pysetdata,flag)
      use mo_nad, only: d => df

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_mo_nad_getdims_df
      subroutine f2py_mo_nad_getdims_xi1_ad(r,s,f2pysetdata,flag)
      use mo_nad, only: d => xi1_ad

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_mo_nad_getdims_xi1_ad
      subroutine f2py_mo_nad_getdims_r_ad(r,s,f2pysetdata,flag)
      use mo_nad, only: d => r_ad

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_mo_nad_getdims_r_ad
      subroutine f2py_mo_nad_getdims_c1_ad(r,s,f2pysetdata,flag)
      use mo_nad, only: d => c1_ad

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_mo_nad_getdims_c1_ad
      subroutine f2py_mo_nad_getdims_a_f(r,s,f2pysetdata,flag)
      use mo_nad, only: d => a_f

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_mo_nad_getdims_a_f
      subroutine f2py_mo_nad_getdims_c1(r,s,f2pysetdata,flag)
      use mo_nad, only: d => c1

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_mo_nad_getdims_c1
      subroutine f2py_mo_nad_getdims_x_ly(r,s,f2pysetdata,flag)
      use mo_nad, only: d => x_ly

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_mo_nad_getdims_x_ly
      subroutine f2py_mo_nad_getdims_rs(r,s,f2pysetdata,flag)
      use mo_nad, only: d => rs

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_mo_nad_getdims_rs
      subroutine f2py_mo_nad_getdims_a_f_ad(r,s,f2pysetdata,flag)
      use mo_nad, only: d => a_f_ad

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_mo_nad_getdims_a_f_ad
      subroutine f2py_mo_nad_getdims_lai_ad(r,s,f2pysetdata,flag)
      use mo_nad, only: d => lai_ad

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_mo_nad_getdims_lai_ad
      subroutine f2py_mo_nad_getdims_xi1(r,s,f2pysetdata,flag)
      use mo_nad, only: d => xi1

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_mo_nad_getdims_xi1
      subroutine f2py_mo_nad_getdims_r(r,s,f2pysetdata,flag)
      use mo_nad, only: d => r

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_mo_nad_getdims_r
      subroutine f2py_mo_nad_getdims_i0_ad(r,s,f2pysetdata,flag)
      use mo_nad, only: d => i0_ad

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1),s(2),s(3)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_mo_nad_getdims_i0_ad
      subroutine f2py_mo_nad_getdims_ximt(r,s,f2pysetdata,flag)
      use mo_nad, only: d => ximt

      integer flag
      external f2pysetdata
      logical ns
      integer r,i,j
      integer(8) s(*)
      ns = .FALSE.
      if (allocated(d)) then
         do i=1,r
            if ((size(d,i).ne.s(i)).and.(s(i).ge.0)) then
               ns = .TRUE.
            end if
         end do
         if (ns) then
            deallocate(d)
         end if
      end if
      if ((.not.allocated(d)).and.(s(1).ge.1)) then
       allocate(d(s(1)))
      end if
      if (allocated(d)) then
         do i=1,r
            s(i) = size(d,i)
         end do
      end if
      flag = 1
      call f2pysetdata(d,allocated(d))
      end subroutine f2py_mo_nad_getdims_ximt
      
      subroutine f2pyinitmo_nad(f2pysetupfunc)
      use mo_nad, only : h_c_ad
      use mo_nad, only : x_nf
      use mo_nad, only : tl_ad
      use mo_nad, only : ag
      use mo_nad, only : df_ad
      use mo_nad, only : ximt_ad
      use mo_nad, only : cg
      use mo_nad, only : number
      use mo_nad, only : h_c
      use mo_nad, only : nlm
      use mo_nad, only : n_c
      use mo_nad, only : nwmaxx
      use mo_nad, only : xif
      use mo_nad, only : xi1u
      use mo_nad, only : xi1u_ad
      use mo_nad, only : rs_ad
      use mo_nad, only : xif_ad
      use mo_nad, only : tl
      use mo_nad, only : points
      use mo_nad, only : rl_ad
      use mo_nad, only : rl
      use mo_nad, only : pi
      use mo_nad, only : nw
      use mo_nad, only : i0
      use mo_nad, only : bg
      use mo_nad, only : lai
      use mo_nad, only : phi_0
      use mo_nad, only : df
      use mo_nad, only : dg
      use mo_nad, only : xi1_ad
      use mo_nad, only : r_ad
      use mo_nad, only : c1_ad
      use mo_nad, only : a_f
      use mo_nad, only : c1
      use mo_nad, only : ild
      use mo_nad, only : x_ly
      use mo_nad, only : rs
      use mo_nad, only : a_f_ad
      use mo_nad, only : lai_ad
      use mo_nad, only : xi1
      use mo_nad, only : r
      use mo_nad, only : weights
      use mo_nad, only : teta_0
      use mo_nad, only : i0_ad
      use mo_nad, only : ximt
      external f2pysetupfunc
      external f2py_mo_nad_getdims_h_c_ad
      external f2py_mo_nad_getdims_x_nf
      external f2py_mo_nad_getdims_tl_ad
      external f2py_mo_nad_getdims_df_ad
      external f2py_mo_nad_getdims_ximt_ad
      external f2py_mo_nad_getdims_h_c
      external f2py_mo_nad_getdims_xif
      external f2py_mo_nad_getdims_xi1u
      external f2py_mo_nad_getdims_xi1u_ad
      external f2py_mo_nad_getdims_rs_ad
      external f2py_mo_nad_getdims_xif_ad
      external f2py_mo_nad_getdims_tl
      external f2py_mo_nad_getdims_rl_ad
      external f2py_mo_nad_getdims_rl
      external f2py_mo_nad_getdims_i0
      external f2py_mo_nad_getdims_lai
      external f2py_mo_nad_getdims_df
      external f2py_mo_nad_getdims_xi1_ad
      external f2py_mo_nad_getdims_r_ad
      external f2py_mo_nad_getdims_c1_ad
      external f2py_mo_nad_getdims_a_f
      external f2py_mo_nad_getdims_c1
      external f2py_mo_nad_getdims_x_ly
      external f2py_mo_nad_getdims_rs
      external f2py_mo_nad_getdims_a_f_ad
      external f2py_mo_nad_getdims_lai_ad
      external f2py_mo_nad_getdims_xi1
      external f2py_mo_nad_getdims_r
      external f2py_mo_nad_getdims_i0_ad
      external f2py_mo_nad_getdims_ximt
      call f2pysetupfunc(f2py_mo_nad_getdims_h_c_ad,f2py_mo_nad_getdims_&
     &x_nf,f2py_mo_nad_getdims_tl_ad,ag,f2py_mo_nad_getdims_df_ad,f2py_m&
     &o_nad_getdims_ximt_ad,cg,number,f2py_mo_nad_getdims_h_c,nlm,n_c,nw&
     &maxx,f2py_mo_nad_getdims_xif,f2py_mo_nad_getdims_xi1u,f2py_mo_nad_&
     &getdims_xi1u_ad,f2py_mo_nad_getdims_rs_ad,f2py_mo_nad_getdims_xif_&
     &ad,f2py_mo_nad_getdims_tl,points,f2py_mo_nad_getdims_rl_ad,f2py_mo&
     &_nad_getdims_rl,pi,nw,f2py_mo_nad_getdims_i0,bg,f2py_mo_nad_getdim&
     &s_lai,phi_0,f2py_mo_nad_getdims_df,dg,f2py_mo_nad_getdims_xi1_ad,f&
     &2py_mo_nad_getdims_r_ad,f2py_mo_nad_getdims_c1_ad,f2py_mo_nad_getd&
     &ims_a_f,f2py_mo_nad_getdims_c1,ild,f2py_mo_nad_getdims_x_ly,f2py_m&
     &o_nad_getdims_rs,f2py_mo_nad_getdims_a_f_ad,f2py_mo_nad_getdims_la&
     &i_ad,f2py_mo_nad_getdims_xi1,f2py_mo_nad_getdims_r,weights,teta_0,&
     &f2py_mo_nad_getdims_i0_ad,f2py_mo_nad_getdims_ximt)
      end subroutine f2pyinitmo_nad

      module     multiple_dom_store_ad
      implicit none
      integer :: multkl_multiple_dom
      double precision, allocatable :: multkl_xi_1h(:,:,:)
      double precision, allocatable :: multkl_xi_2h(:,:,:)
      integer :: multl_multiple_dom
      double precision, allocatable :: multl_s_1h(:,:,:,:)
      double precision, allocatable :: multl_s_3h(:,:,:,:)
      double precision, allocatable :: multl_xi_2h(:,:,:,:)
      double precision, allocatable :: multl_xi_4h(:,:,:,:)

      end module     multiple_dom_store_ad

module mo_nad
      integer nw,nwmaxx
      integer, parameter :: nlm = 10   ! down from 50???          ! max number passes in multi-scattering loop
      double precision, parameter :: pi = 3.1415926535898

      double precision,allocatable :: lai_ad(:)
      double precision,allocatable :: rl_ad(:)
      double precision,allocatable  :: tl_ad(:)

      double precision,allocatable :: lai(:)
      double precision,allocatable :: rl(:)
      double precision,allocatable  :: tl(:)

      double precision :: points(32)
      double precision :: weights(32)

      integer :: ild
      integer :: number

      double precision,allocatable  :: xi1_ad(:)
      double precision,allocatable  :: ximt_ad(:)
      double precision,allocatable  :: xi1(:)
      double precision,allocatable  :: ximt(:)

      double precision :: phi_0
      double precision :: teta_0

      double precision,allocatable :: i0(:,:,:)
      double precision,allocatable :: xi1u(:,:,:)
      double precision,allocatable :: xif(:,:,:)

      double precision,allocatable :: i0_ad(:,:,:)
      double precision,allocatable :: xi1u_ad(:,:,:)
      double precision,allocatable :: xif_ad(:,:,:)

      double precision,allocatable :: rs(:)
      double precision,allocatable :: rs_ad(:)

      double precision,allocatable :: c1(:)
      double precision,allocatable  :: c1_ad(:)

      double precision,allocatable :: a_f(:)
      double precision,allocatable :: df(:)
      double precision,allocatable :: h_c(:)
      integer :: n_c
      double precision,allocatable :: r(:)
      double precision,allocatable :: x_ly(:)
      double precision,allocatable :: x_nf(:)

      double precision,allocatable  :: a_f_ad(:)
      double precision,allocatable :: df_ad(:)
      double precision,allocatable :: h_c_ad(:)
      double precision,allocatable :: r_ad(:)


      double precision :: ag
      double precision :: bg
      double precision :: cg
      double precision :: dg
end module mo_nad
      subroutine nad_allocate(nbands_to_use)
      use mo_nad
      use dataSpec_p5
      implicit none
	integer nbands_to_use
! all of these need to be allocated of size nwmax
! but when they are used, it will be just those wavebands we need
! so they all have to be qualified e.g. lai_ad(1:nw)
      call nad_deallocate()
	nwmaxx = nbands_to_use
!      print*,'ALLOC: nad_allocate',nbands_to_use
      allocate(lai_ad(nwmaxx))
      allocate(lai(nwmaxx))
      allocate(rl_ad(nwmaxx))
      allocate(tl_ad(nwmaxx))
      allocate(rs_ad(nwmaxx))
      allocate(rl(nwmaxx))
      allocate(tl(nwmaxx))
      allocate(rs(nwmaxx))
      allocate(xi1_ad(nwmaxx))
      allocate(ximt_ad(nwmaxx))
      allocate(xi1(nwmaxx))
      allocate(ximt(nwmaxx))
      allocate(i0(21,40,nwmaxx))
      allocate(xi1u(21,40,nwmaxx))
      allocate(xif(21,40,nwmaxx))
      allocate(i0_ad(21,40,nwmaxx))
      allocate(xi1u_ad(21,40,nwmaxx))
      allocate(xif_ad(21,40,nwmaxx))
      allocate(c1_ad(nwmaxx))
      allocate(c1(nwmaxx))
      allocate(a_f_ad(nwmaxx))
      allocate(a_f(nwmaxx))
      allocate(df_ad(nwmaxx))
      allocate(df(nwmaxx))
      allocate(h_c_ad(nwmaxx))
      allocate(h_c(nwmaxx))
      allocate(r_ad(nwmaxx))
      allocate(r(nwmaxx))
      allocate(x_nf(nwmaxx))
      allocate(x_ly(nwmaxx))

      end subroutine
      subroutine nad_deallocate()
        use mo_nad
        implicit none
!      print*,'DEALLOC: nad_deallocate'
      if(allocated(lai_ad))deallocate(lai_ad)
      if(allocated(lai))deallocate(lai)
      if(allocated(rl_ad))deallocate(rl_ad)
      if(allocated(tl_ad))deallocate(tl_ad)
      if(allocated(rs_ad))deallocate(rs_ad)
      if(allocated(rl))deallocate(rl)
      if(allocated(tl))deallocate(tl)
      if(allocated(rs))deallocate(rs)
      if(allocated(xi1_ad))deallocate(xi1_ad)
      if(allocated(ximt_ad))deallocate(ximt_ad)
      if(allocated(xi1))deallocate(xi1)
      if(allocated(ximt))deallocate(ximt)
      if(allocated(i0))deallocate(i0)
      if(allocated(xi1u))deallocate(xi1u)
      if(allocated(xif))deallocate(xif)
      if(allocated(i0_ad))deallocate(i0_ad)
      if(allocated(xi1u_ad))deallocate(xi1u_ad)
      if(allocated(xif_ad))deallocate(xif_ad)
      if(allocated(c1_ad))deallocate(c1_ad)
      if(allocated(c1))deallocate(c1)
      if(allocated(a_f_ad))deallocate(a_f_ad)
      if(allocated(a_f))deallocate(a_f)
      if(allocated(df_ad))deallocate(df_ad)
      if(allocated(df))deallocate(df)
      if(allocated(h_c_ad))deallocate(h_c_ad)
      if(allocated(h_c))deallocate(h_c)
      if(allocated(r_ad))deallocate(r_ad)
      if(allocated(r))deallocate(r)
      if(allocated(x_nf))deallocate(x_nf)
      if(allocated(x_ly))deallocate(x_ly)

      end subroutine

      subroutine nad_zero
        use mo_nad
        implicit none
        lai_ad=0
        lai=0
        rl_ad=0
        tl_ad=0
        rs_ad=0
        rl=0
        tl=0
        rs=0
        xi1_ad=0
        ximt_ad=0
        xi1=0
        ximt=0
        i0=0
        xi1u=0
        xif=0
        i0_ad=0
        xi1u_ad=0
        xif_ad=0
        c1_ad=0
        c1=0
        a_f_ad=0
        a_f=0
        df_ad=0
        df=0
        h_c_ad=0
        h_c=0
        r_ad=0
        r=0
        x_nf=0
        x_ly=0
      end subroutine nad_zero
      subroutine nad_mult_n(npt)
      use multiple_dom_store_ad
      use mo_nad
      implicit none
      integer npt
      multkl_multiple_dom = nlm*21*npt
      multl_multiple_dom = nlm*npt
      end subroutine nad_mult_n

      subroutine nad_mult_allocate()
      use multiple_dom_store_ad
      use dataSpec_p5
!	use mo_rtmodel
      use mo_nad
      implicit none
!      print*,'ALLOC: nad_mult_allocate',nw,multkl_multiple_dom,multl_multiple_dom
      allocate( multkl_xi_1h(40,multkl_multiple_dom,nwmaxx))
      allocate( multkl_xi_2h(40,multkl_multiple_dom,nwmaxx))
      allocate(  multl_s_1h(21,40,multl_multiple_dom,nwmaxx))
      allocate( multl_xi_2h(21,40,multl_multiple_dom,nwmaxx))
      allocate(  multl_s_3h(21,40,multl_multiple_dom,nwmaxx))
      allocate(multl_xi_4h(21,40,multl_multiple_dom,nwmaxx))
      end subroutine nad_mult_allocate

      subroutine nad_mult_deallocate()
      use multiple_dom_store_ad
      implicit none
!      print*,'DEALLOC: nad_mult_deallocate'
      if (allocated(multkl_xi_1h))deallocate( multkl_xi_1h )
      if (allocated(multkl_xi_2h))deallocate( multkl_xi_2h )
      if (allocated(multl_s_1h))deallocate( multl_s_1h )
      if (allocated(multl_xi_2h))deallocate( multl_xi_2h )
      if (allocated(multl_s_3h))deallocate( multl_s_3h )
      if (allocated(multl_xi_4h))deallocate( multl_xi_4h )
      end subroutine nad_mult_deallocate
